<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag delivery possibilities table
	 */

	load_f('pagination');
	load_f('mb_wrap');

	class DELIVERYLIST	{

		var $COLUMN_names	=	array(	'contactname', 'delivery_day_of_week', 'date_of_deadline', 'orderID', 
							'code', 'articalname', 'unit', 'stock_quantity', 'order_quantity', 'Row'	);

		var $COLUMN_names_AS	=	array();

		var $FILTER_type	=	array(	'contactname'=>'box', 'delivery_day_of_week'=>'listbox', 'date_of_deadline'=>'date', 'orderID'=>'box', 
							'code'=>'box', 'articalname'=>'box', 'unit'=>'none', 'stock_quantity'=>'none', 'order_quantity'=>'none', 'Row'=>'none'	);

		var $TABLE		=	'';
		var $ROW_FILTER		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COLUMNS		=	FALSE;
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $SORT		=	'cadc8c8db42409733582cb3e2298ef87';
		var $COMMAND		=	'';

		function __construct($INCREMENT)	{

			$this->INC		=	$INCREMENT;
			$this->BASE		=	$_SESSION['BASE'];
			$this->STOCKBASE	=	'ebagstock';

			global $__SQL, $__LANG, $__CONF, $__BOX;

			$this->SQL		=	&$__SQL;
			$this->LANG		=	&$__LANG;
			$this->BOX		=	&$__BOX;
			$this->FORMAT		=	$__CONF->get('date', 'sql_format');

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->FILTER_state[$COLUMN]	=	FALSE;
				$this->COLUMN_names_AS[$COLUMN] = 	$this->LANG->get($COLUMN);
			}
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	'</tr>'."\n";
		}

		/**
		 * Create tabe row with filters
		 */

		private function TABLEFILTERS()	{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$VALUE	=	'';

				if ($this->FILTER_type[$COLUMN]=='none') $this->ROW_FILTER .= '<td></td>'."\n";

				# Adds listbox (note: simplies version only to use in this class)

				if ($this->FILTER_type[$COLUMN]=='listbox')	{

						$STYLE = 'style="width : '.$this->BOX->size($COLUMN).'px;"';

						$this->ROW_FILTER .=	"<td>\n<select $STYLE name=\"$COLUMN\">\n";

						# the all will be empty=>false

						if ($this->FILTER_state[$COLUMN]===FALSE)	{$selected='selected';}	else {$selected='';}

						$this->ROW_FILTER .= "<option $selected value=\"\">".$this->LANG->get('all')."</option>\n";

						if ($this->FILTER_state[$COLUMN] == $this->SORT)  {$selected='selected';} else {$selected='';}

						$this->ROW_FILTER .= "<option $selected value=\"$this->SORT\">".$this->LANG->get('sort')."</option>\n";
						
						if ($this->FILTER_state[$COLUMN] == $this->SORT)  $selected='';

						$DAYNUMBERS = array(1, 2, 3, 4, 5, 6, 0);

						foreach ($DAYNUMBERS as $VALUE)		{
							
							$TXT	= $this->LANG->get("day$VALUE");

							if (($this->FILTER_state[$COLUMN]!==FALSE) && ($this->FILTER_state[$COLUMN]==$VALUE) &&  ($this->FILTER_state[$COLUMN] != $this->SORT)) {$selected='selected';} else {$selected = '';}

							$this->ROW_FILTER .= "<option $selected value=\"$VALUE\">$TXT</option>\n";
						}

						$this->ROW_FILTER .=  "</select>\n</td>\n";
				}

				# Adds box or date box

				if (($this->FILTER_type[$COLUMN] == 'box') or ($this->FILTER_type[$COLUMN] == 'date'))	{

					if ($this->FILTER_type[$COLUMN] == 'date')	{

						if ($this->FILTER_state[$COLUMN])	{

							$DATE	=	explode('/', $this->FILTER_state[$COLUMN]);

							if ($DATE[0] != '-') {$DATE[0]='d'.$DATE[0];} else {$DATE[0]='';}
							if ($DATE[1] != '-') {$DATE[1]='m'.$DATE[1];} else {$DATE[1]='';}
							if ($DATE[2] != '-') {$DATE[2]='y'.$DATE[2];} else {$DATE[2]='';}

							$VALUE	= $DATE[0].$DATE[1].$DATE[2];
						}

					}	else	{

						$VALUE	= $this->FILTER_state[$COLUMN];

					}
						
					if ($COLUMN == 'orderID') {$CLASS = 'filter-input-mini';} else {$CLASS = 'filter-input';}

					$this->ROW_FILTER .= "<td>\n<input class=\"$CLASS\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

					unset($DATE);
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		private function FORMCOMMAND()	{

			# note: because of temporary tables the command must be form always

			# create temporary tables

			$_SESSION['TEMPTABLE1']	=	"SELECT	orders_data.personID AS Row, orders_data.orderID, orders_data.code, orders_data.articalname, 
								orders_data.unit, finished_goods_stock.quantity AS stock_quantity, orders_data.quantity AS order_quantity
							 FROM $this->BASE.orders_data INNER JOIN $this->STOCKBASE.finished_goods_stock
							 ON orders_data.code=finished_goods_stock.code
							 WHERE 	finished_goods_stock.quantity >= orders_data.quantity
								AND orders_data.date_of_delivery IS NULL
								AND ((orders_data.productionorderID IS NULL) OR (orders_data.productionorderID NOT IN (SELECT `personID` FROM $this->BASE.production_orders_header WHERE `date_of_finishing` IS NULL AND `deleted` IS NOT NULL)))
							 	AND orders_data.deleted IS NOT NULL";

			$_SESSION['TEMPTABLE1']	=	"CREATE TEMPORARY TABLE $this->BASE.tempstocktable ".$_SESSION['TEMPTABLE1'];

			$this->SQL->query($_SESSION['TEMPTABLE1']);

			$SEARCH		=	'';

			if ($this->FILTER_state['contactname']!==FALSE) $SEARCH .= " AND orders_header.contactname REGEXP '".($this->SQL->s_escape($this->FILTER_state['contactname'], 'REGEXP'))."' ";

			if ($this->FILTER_state['orderID']!==FALSE)  	$SEARCH .= " AND orders_header.personID='".($this->SQL->s_escape($this->FILTER_state['orderID']))."' ";

			$_SESSION['TEMPTABLE2']	=	"SELECT orders_header.contactname, orders_header.delivery_day_of_week,
								orders_header.date_of_deadline, tempstocktable.orderID,
								tempstocktable.Row, tempstocktable.code, tempstocktable.articalname, tempstocktable.unit,
								tempstocktable.stock_quantity, tempstocktable.order_quantity
							 FROM $this->BASE.tempstocktable INNER JOIN $this->BASE.orders_header
							 ON orders_header.personID=tempstocktable.orderID
							 WHERE orders_header.deleted IS NOT NULL ".$SEARCH;

			$_SESSION['TEMPTABLE2']	=	"CREATE TEMPORARY TABLE $this->BASE.temptable ".$_SESSION['TEMPTABLE2'];

			$this->SQL->query($_SESSION['TEMPTABLE2']);

			$SEARCH		=	'';

			if ($this->FILTER_state['delivery_day_of_week']!==FALSE) {
			
				if ($this->FILTER_state['delivery_day_of_week'] == $this->SORT)	{
			
					$ORDERBY = ' ORDER BY `delivery_day_of_week` ';
					  
				}	else	   {
				
					$SEARCH .= " AND `delivery_day_of_week`='".($this->SQL->s_escape($this->FILTER_state['delivery_day_of_week']))."' ";					
				}
			}

			if ($this->FILTER_state['code']!==FALSE) $SEARCH .= "AND `code` REGEXP '".($this->SQL->s_escape($this->FILTER_state['code'], 'REGEXP'))."' ";

			if ($this->FILTER_state['articalname']!==FALSE) $SEARCH .= "AND `articalname` REGEXP '".($this->SQL->s_escape($this->FILTER_state['articalname'], 'REGEXP'))."' ";

			if ($this->FILTER_state['date_of_deadline']!==FALSE)	{

				$DATE	= 	explode('/', $this->FILTER_state['date_of_deadline']);

				if ($DATE[0]!='-') $SEARCH	.=	" AND DAY(date_of_deadline)=".$DATE[0].' ';

				if ($DATE[1]!='-') $SEARCH	.=	" AND MONTH(date_of_deadline)=".$DATE[1].' ';

				if ($DATE[2]!='-') $SEARCH	.=	" AND YEAR(date_of_deadline)=".$DATE[2].' ';

				unset($DATE);
			}
			
			if (! isset($ORDERBY)) $ORDERBY = ' ORDER BY `contactname` ';

			$_SESSION['COMMAND']	=	$this->COMMAND	=	"SELECT SQL_CALC_FOUND_ROWS 
											`Row`, `contactname`, `delivery_day_of_week`, 
											DATE_FORMAT(`date_of_deadline`, '$this->FORMAT') AS `date_of_deadline`,
											`orderID`, `code`, `articalname`, `unit`, `stock_quantity`, `order_quantity`
										 FROM $this->BASE.temptable WHERE `orderID` IS NOT NULL ".$SEARCH.$ORDERBY;

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');
			$DELIVERY	=	$this->LANG->get('delivery');

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					switch ($COLUMN)	{

						case('orderID')			:	$orderID 	=	$VALUE;
											break;

						case('Row')			:	$deliveryID	=	$VALUE;
											break;

						case ('delivery_day_of_week')	:	$VALUE		=	$this->LANG->get("day$VALUE");
											break;
					}

					# note: row is not printed, needs for link

					if ($COLUMN != 'Row') $this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"3\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=orderdetails&amp;id=$orderID\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n"
							."<a class=\"list-link\" href=\"loader.php?cat=singledelivery&amp;id=$deliveryID\">$DELIVERY</a>&nbsp;&nbsp;&nbsp;\n"
							."</td>\n";
				$this->TABLE_BODY .= "</tr>\n";
			}

			$this->SQL->free();
		}


		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_POST['FILTER']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = 0;

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((isset($_POST[$COLUMN])) && (! is_empty($_POST[$COLUMN])))	{

						if ($this->FILTER_type[$COLUMN]=='date')	{

							if (! function_exists('date2search')) load_f('date2search');

							$this->FILTER_state[$COLUMN] = date2search($_POST[$COLUMN], $this->LANG->get('datesearchdaysign'), $this->LANG->get('datesearchmonthsign'), $this->LANG->get('datesearchyearsign'));

						}	else	  {

							$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];
						}
					}
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state 	=	$_SESSION['FILTERS'];
			}
		}

		/**
		 * Displays the table;
		 */

		public function create()	{

			$_SESSION['DROPTABLE1']	= "DROP TEMPORARY TABLE IF EXISTS $this->BASE.temptable";
			$_SESSION['DROPTABLE2']	= "DROP TEMPORARY TABLE IF EXISTS $this->BASE.tempstocktable ";

			$this->SQL->query($_SESSION['DROPTABLE1']);
			$this->SQL->query($_SESSION['DROPTABLE2']);

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);

			$this->SQL->query($_SESSION['DROPTABLE1']);
			$this->SQL->query($_SESSION['DROPTABLE2']);
		}
	}
?>
