<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag SEARCH class
	 */

	load_f('pagination');
	load_f('mb_wrap');

	class SEARCH	{

		var $COLUMN_names	=	array();
		var $COLUMN_names_AS	=	array();
		var $TABLE		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COMMAND		=	'';
		var $COLUMNS		=	'';
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $DATES		=	array('date', 'date_of_creation', 'date_of_deadline', 'date_of_finishing', 'date_of_employment', 'date_of_order');

		function __construct($TABLE, $NEWLINK, $CONTROLLER1, $CONTROLLER2, $CONTROLLER3, $INCREMENT, $LIMIT)	{

			$this->SQLTABLE	=	$TABLE;
			$this->NEWLINK	=	$NEWLINK;	
			$this->CONT1	=	$CONTROLLER1;
			$this->CONT2	=	$CONTROLLER2;
			$this->CONT3	=	$CONTROLLER3;
			$this->INC	=	$INCREMENT;
			$this->LIMIT	=	$LIMIT;
			$COMMAND	=	'';
			$WHERE		=	'';
			$PAGE		=	0;
	
			global $__SQL, $__LANG, $__BOX, $__CONF;

			$this->SQL	=	&$__SQL;
			$this->LANG	=	&$__LANG;
			$this->BOX	=	&$__BOX;
			$this->CONF	=	&$__CONF;
			$this->BASE	=	$_SESSION['BASE'];

			unset($_SESSION['ID']);
		}

		/**
		 * Sets the columns to display
		 */
		
		public function column($COLUMNS)	{

			if (! is_array($COLUMNS)) $COLUMNS=array($COLUMNS);

			foreach ($COLUMNS as $COLUMN)	{

				array_push($this->COLUMN_names, $COLUMN);
			
				$this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($COLUMN);
			}
		}

		/**
		 * Sets searched items
		 */

		public function addsearch($POST)	{

			$this->ITEMS	=	$POST;
		}

		/**
		 * Return current tablename (from base.table)
	 	 */

		private function gettable()	{

			$array = explode('.', $this->SQLTABLE);
			return $array[1];
		}
	
		/**
		 * Adds filter command
		 */

		private function addfilter($FILTER)	{

			if (! $this->WHERE) {$AND = ' WHERE ';} else {$AND = ' AND ';}

			$this->WHERE .= " $AND $FILTER ";
		}

		/**
		 * Adds columns to search
		 */

		private function addcolumn($COLUMN)	{

			if (in_array($COLUMN, $this->DATES))	{

				$COLUMN = "DATE_FORMAT(`$COLUMN`, '".$this->CONF->get('date', 'sql_format')."') AS `$COLUMN`";
			}	else	{

				$COLUMN = "`$COLUMN`";
			}

			if (! $this->COLUMNS) {$this->COLUMNS = $COLUMN;} else {$this->COLUMNS .= ", $COLUMN";}
		}

		/**
		 * Gets the searched post array & forms sql command;
	 	 */

		public function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				foreach ($this->COLUMN_names as $COLUMN) $this->addcolumn($COLUMN);

				$this->WHERE	=	'';

				$EQUALS		=	array('personID', 'type', 'delivery_day_of_week', 'origin', 'supplierID', 'ordered', 'payment_form', 'delivery_form', 'employeeID', 'month', 'tax');

				$NUMERICS	=	array('price', 'price_with_tax', 'purchase_price', 'calculation_price', 'quantity', 'quantity_ordered', 'quantity_ordered_to_stock', 'quantity_in_production');

				foreach ($this->ITEMS as $BOX=>$VALUE)		{

					if (! is_empty($VALUE))	  {

						if (in_array($BOX, $EQUALS))	{

							$this->addfilter("`$BOX`='".$this->SQL->escape($VALUE)."'");
							continue;
						}

						if (in_array($BOX, $NUMERICS))	{

							$this->addfilter("$BOX $VALUE");
							continue;
						}

						if (in_array($BOX, $this->DATES))	{

							if (! function_exists('date2search')) load_f('date2search');

							$VALUE = date2search($VALUE, $this->LANG->get('datesearchdaysign'), $this->LANG->get('datesearchmonthsign'), $this->LANG->get('datesearchyearsign'));

							$DATE	= 	explode('/', $VALUE);

							if ($DATE[0]!='-') $this->addfilter(" DAY($BOX)=".$DATE[0]);

							if ($DATE[1]!='-') $this->addfilter(" MONTH($BOX)=".$DATE[1]);

							if ($DATE[2]!='-') $this->addfilter(" YEAR($BOX)=".$DATE[2]);

							unset($DATE);

							continue;
						}


						switch($BOX)	{

							case('servicecode')		:	if ($this->gettable()=='services_header')	{

													$this->addfilter("`personID` IN (SELECT `reversID` FROM $this->BASE.services_data WHERE `deleted` IS NOT NULL AND `code` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' GROUP BY `reversID` )");
												}

												break;

							case('offeredcode')		:	if ($this->gettable()=='offers_header')	{

													$this->addfilter("`personID` IN (SELECT `offerID` FROM $this->BASE.offers_data WHERE `deleted` IS NOT NULL AND `code` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' GROUP BY `offerID` )");
												}

												break;

							case('orderedcode')		:	if ($this->gettable()=='orders_header')	{

													$this->addfilter("`personID` IN (SELECT `orderID` FROM $this->BASE.orders_data WHERE `deleted` IS NOT NULL AND `code` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' GROUP BY `orderID` )");
												}

												break;

							case('deliveredcode')		:	if ($this->gettable()=='deliverys_header')	{

													$this->addfilter("`personID` IN (SELECT `deliveryID` FROM $this->BASE.deliverys_data WHERE `deleted` IS NOT NULL AND `code` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' GROUP BY `deliveryID` )");
												}

												break;

							case('billedcode')		:	if ($this->gettable()=='bills_header')	{

													$this->addfilter("`personID` IN (SELECT `billID` FROM $this->BASE.bills_data WHERE `deleted` IS NOT NULL AND `code` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' GROUP BY `billID` )");
												}

												break;

							case('ordered2stockcode')	:	if ($this->gettable()=='orders_to_stock_header')	{

													$this->addfilter("`personID` IN (SELECT `order2stockID` FROM $this->BASE.orders_to_stock_data WHERE `deleted` IS NOT NULL AND `code` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' GROUP BY `order2stockID` )");
												}

												break;

							case('billedorigin')		:	if ($this->gettable()=='bills_header')	{

													if (isset($_SESSION['year_is_closed'])) {$BASE = $this->BASE;} else {$BASE = 'ebagstock';}

													$this->addfilter("`personID` IN (SELECT `billID` FROM $this->BASE.bills_data WHERE `deleted` IS NOT NULL AND `code` IN (SELECT `code` FROM $BASE.finished_goods_stock WHERE `origin`='".$this->SQL->escape($VALUE)."' AND `deleted` IS NOT NULL) GROUP BY `billID` )");
												}

												break;

							case('servicequantity')		:	if ($this->gettable()=='services_header')	{

													$this->addfilter("`personID` IN (SELECT `reversID` FROM $this->BASE.services_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `reversID` )");
												}

												break;

							case('offeredquantity')		:	if ($this->gettable()=='offers_header')	{

													$this->addfilter("`personID` IN (SELECT `offerID` FROM $this->BASE.offers_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `offerID` )");
												}

												break;

							case('orderedquantity')		:	if ($this->gettable()=='orders_header')	{

													$this->addfilter("`personID` IN (SELECT `orderID` FROM $this->BASE.orders_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `orderID` )");
												}

												break;

							case('deliveredquantity')		:	if ($this->gettable()=='deliverys_header')	{

													$this->addfilter("`personID` IN (SELECT `deliveryID` FROM $this->BASE.deliverys_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `deliveryID` )");
												}

												break;

							case('billedquantity')		:	if ($this->gettable()=='bills_header')	{

													$this->addfilter("`personID` IN (SELECT `billID` FROM $this->BASE.bills_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `billID` )");
												}

												break;

							case('ordered2stockquantity')	:	if ($this->gettable()=='orders_to_stock_header')	{

													$this->addfilter("`personID` IN (SELECT `order2stockID` FROM $this->BASE.orders_to_stock_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `order2stockID` )");
												}

												break;

							case('orderedorigin')		:	if ($this->gettable()=='orders_header')	{

													if (isset($_SESSION['year_is_closed'])) {$BASE = $this->BASE;} else {$BASE = 'ebagstock';}

													$this->addfilter("`personID` IN (SELECT `orderID` FROM $this->BASE.orders_data WHERE `deleted` IS NOT NULL AND `code` IN (SELECT `code` FROM $BASE.finished_goods_stock WHERE `origin`='$VALUE' AND `deleted` IS NOT NULL))");
												}

												break;


							case('feedstockcode')		:	$TABLE	=	$this->gettable();	

												if ($TABLE == 'services')	{

													if (isset($_SESSION['year_is_closed'])) {$BASE = $this->BASE;} else {$BASE = 'ebagstock';}

													$this->addfilter("personID IN (SELECT `serviceID` FROM $BASE.feedstock_requests_list WHERE `code` REGEXP ".$this->SQL->s_escape($VALUE, 'REGEXP')." AND `deleted` IS NOT NULL)");
												}

												if ($TABLE == 'production_orders_header')	{

													$this->addfilter("personID IN (SELECT `productionorderID` FROM $this->BASE.production_orders_data WHERE `code` REGEXP ".$this->SQL->s_escape($VALUE, 'REGEXP')." AND `deleted` IS NOT NULL GROUP BY `productionorderID`)");
												}

												break;

							case('feedstockquantity')	:	if ($this->gettable() == 'production_orders_header')	{

													$this->addfilter("`personID` IN (SELECT `productionorderID` FROM $this->BASE.production_orders_data WHERE `deleted` IS NOT NULL AND quantity".html_entity_decode($VALUE, ENT_COMPAT, 'UTF-8')." GROUP BY `productionorderID` )");
												}

												break;

							case('delivery')		:	$this->addfilter("`delivery_country` IS NOT NULL");
												break;

							case('discount_price')		:	$SIGN	=	preg_replace('/[0-9]/is', '', $VALUE);
												$QUANT	=	preg_replace("/$SIGN/is", '', $VALUE);
												$QUANT	=	($QUANT *100) / (100 - $_SESSION['discount']);

												$this->addfilter("price $SIGN $QUANT");
												break;

							case('finisher')		:	$SEARCHED = array();

												$SEARCHED_STR	=	$this->SQL->s_escape($VALUE, 'REGEXP');

												$this->SQL->query("	(SELECT `personID`, ('cooperator') AS `type` FROM $this->BASE.addressbook WHERE `contactname` REGEXP '$SEARCHED_STR' AND `contacttype`='4' AND `deleted` IS NOT NULL)
															UNION ALL
															(SELECT `personID`, ('employee') AS `type` FROM $this->BASE.employees WHERE `employeename` REGEXP '$SEARCHED_STR' AND DELETED IS NOT NULL)");

												if ($this->SQL->num_rows())	{

													while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{
	
														$FOUND = "'".$RESULT['type'].'_'.$RESULT['personID']."'";

														if (! isset($IN)) {$IN = $FOUND;} else {$IN .= ", $FOUND";}
													}

													if ($this->gettable()=='production_orders_header')	{											

														$this->addfilter("personID IN (SELECT `productionorderID` FROM $this->BASE.production_orders_phases WHERE `$BOX` IN ($IN) GROUP BY `productionorderID`)");

													}	else	  {

														$this->addfilter("`$BOX` IN ($IN)");

													}

												}	else	  {

													# not possible, used to not get result

													if ($this->gettable()=='production_orders_header')	{

														$this->addfilter("`personID`='1' AND `personID`='2'");
		
													}	else	   {

														$this->addfilter("`$BOX`='1' AND `$BOX`='2'");
													}
												}

												break;

							case('connected_with_orders')	:	$LIST	=	explode(',', $VALUE);

												foreach ($LIST as $key=>$val)	{

													if (! is_empty($val))	$SORT[$key] = $this->SQL->s_escape('-'.((integer)$val).'-', 'REGEXP');

												}
										
												unset($LIST);

												# not possible

												if (! count($SORT)) $this->addfilter("`personID`='0'");

												foreach ($SORT as $VALUE) $this->addfilter("`$BOX` REGEXP '$VALUE'");

												break;

							case('completelly_delivered')	:	if ($this->gettable()=='orders_to_stock_header')	{

													$this->addfilter("`personID` NOT IN (SELECT `order2stockID` FROM $this->BASE.orders_to_stock_data WHERE `date_of_delivery` IS NULL AND `deleted` IS NOT NULL GROUP BY `order2stockID`)");
												}

												break;

							# note: partially_delivered means in this case not delivered or partically delivered

							case('partially_delivered')	:	if ($this->gettable()=='orders_to_stock_header')	{

													$this->addfilter("`personID` IN (SELECT `order2stockID` FROM $this->BASE.orders_to_stock_data WHERE `date_of_delivery` IS NULL AND `deleted` IS NOT NULL GROUP BY `order2stockID`)");
												}
	
												break;
												
							case('production_type')		:	if ($this->gettable()=='production_orders_header')	{
							  
													# note: 1=>production to orders; 2=>internal production
							
													if ($VALUE == 1) $this->addfilter("`orderID`!=0");
													
													if ($VALUE == 2) $this->addfilter("`orderID`=0");
												}
												
												break;

							case('delivery_list_number')	:
							case('bill_number')		:	$this->addfilter("`personID` IN (SELECT `order2stockID` FROM $this->BASE.orders_to_stock_data WHERE `$BOX` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."' AND `deleted` IS NOT NULL GROUP BY `order2stockID`)");
												break;

							case('secondelivery')		:	$this->addfilter("`delivery_city` IS NOT NULL");
												break;

							case ('offer_in_valuta')	:
							case ('use_session_discount')	:
							case ('use_service_discount')	:
							case ('use_article_discount')	:	if ($VALUE == 1) {$this->addfilter("`$BOX` IS NOT NULL");} else {$this->addfilter("`$BOX` IS NULL");}
												
												break;

							case('fix_payment')		:
							case('working_hour_value')	:	$this->addfilter("`$BOX` IS NOT NULL");
												break;
													
							case('month_part')		:	$month = ceil($VALUE / 3);
							
												if (! ($VALUE % 3))	{
			
													$part = 0;
													
												} elseif (! (($VALUE + 1) % 3)) {

													$part = 2;
													
												}	else 	{
												
													$part = 1;
												}
												
												$this->addfilter("`month`='".$this->SQL->escape($month)."'");
												$this->addfilter("`month_part`='".$this->SQL->escape($part)."'");
												
												break;

													
							default				:	$this->addfilter("`$BOX` REGEXP '".$this->SQL->s_escape($VALUE, 'REGEXP')."'");
												break;
						}
					}
				}

				if (! $this->WHERE) return FALSE;
				
				# Define default ordering
				
				if (in_array('personID', $this->COLUMN_names))	{
				
					$ORDERBY = ' ORDER BY `personID` ';
					
				}	else	 {
				
					$ORDERBY = '';
				}

				$this->COMMAND	=	"SELECT SQL_CALC_FOUND_ROWS $this->COLUMNS FROM $this->SQLTABLE";

				$this->COMMAND .= 	$this->WHERE." AND `deleted` IS NOT NULL ".$ORDERBY;
				
				$_SESSION['COMMAND']	=	$this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;

			return TRUE;
		}

		/**
		 * Localize the data readed from base
		 */

		private function localize($VALUE, $COLUMN)	{

			switch($COLUMN)		{
			
				case('orderID')			:	if ($VALUE) {$TXT = $VALUE;} else {$TXT = '-';}
									break;

				case('contacttype')		:	$TXT = $this->LANG->get("type$VALUE");
									break;

				case('delivery_day_of_week')	:	$TXT = $this->LANG->get("day$VALUE");
									break;

				case('critic')			:	$TXT = $this->LANG->get("critic$VALUE");
									break;

				case('origin')			:	$TXT = $this->LANG->get("origin$VALUE");
									break;

				case('delivered')		:	$TXT = $this->LANG->get("deliverystate$VALUE");
									break;

				case ('payment_form')		:	$TXT		=	'';

									if (isset($this->PAYMENT_TYPES[$VALUE])) $TXT = $this->PAYMENT_TYPES[$VALUE];
								
									break;

				case ('delivery_form')		:	$TXT		=	'';

									if (isset($this->DELIVERY_TYPES[$VALUE])) $TXT = $this->DELIVERY_TYPES[$VALUE];
								
									break;
				case ('connected_with_deliverys'):
				case ('connected_with_reverses'):
				case ('connected_with_orders')	:	if (is_empty($VALUE))	{

										$TXT = $VALUE;
										break;
									}

									$LIST	=	explode('-', $VALUE);

									unset($LIST[count($LIST)-1], $LIST[0]);

									$TXT	=	implode(',', $LIST);

									break;

				case('ordered')			:
				case('billed')			:
				case('finished')		:	$TXT = $this->LANG->get("yesno$VALUE");
									break;

				case ('production_phase')	:	$TXT	=	'';

									if (isset($this->PHASES[$VALUE])) $TXT = $this->PHASES[$VALUE];
								
									break;

				case('finisher')		:	if (is_empty($VALUE))	{

										$TXT = $VALUE;
										break;
									}

									list($TYPE, $FINISHERID)	=	explode('_', $VALUE);

									if ($TYPE == 'employee')	{

										$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

									}	else	   {

										$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
									}

									$this->SQL->query($COMMAND);

									if ($this->SQL->num_rows())	{

										$RESULT	= $this->SQL->RESULT->fetch_row();
										$TXT = $RESULT[0];

									}	else	 {

										$TXT = $this->LANG->get('finisherwasdeleted');
									}

									break;

				case('month')			:	$TXT = $this->LANG->get("monthname$VALUE");
									break;
									
				case('month_part')		:	if ($VALUE == 1) {$TXT = 'I';} elseif ($VALUE == 2) {$TXT = 'II';} else {$TXT = 'I-II';}
									break;

				default				:	$TXT = $VALUE;
			}

			return $TXT;
		}

		/**
		 * Create table header row
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				$CLASS	=	'';

				if ($key == 'personID') {$CLASS = 'class="personID-search"';}	else	{$CLASS = 'class="column-search"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";
			}

			$this->ROW_LABEL	.=	'<td class="filters">'."\n"
						 	."<input name=\"NEW\" class=\"button-list\" type=\"button\" onclick=\"Javascript: location.href='loader.php?cat=$this->NEWLINK&amp;new=1'\" value=\"".$this->LANG->get('newsearch').'">'."\n"
							.'</td><td class="filters">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input name="PRINT" class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	"</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else	  { 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM	=	floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');
			$CHANGE		=	$this->LANG->get('change');
			$DELETE		=	$this->LANG->get('delete');

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $key=>$COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					switch ($COLUMN)	{

						case ('personID')		:	$ID	=	$VALUE;
											break;
						case('orderID')			:
						case ('type')			:
						case ('contacttype')		:
						case ('delivery_day_of_week')	:
						case ('critic')			:
						case ('origin')			:
						case ('ordered')		:
						case ('billed')			:
						case ('delivered')		:
						case ('delivery_form')		:
						case ('payment_form')		:
						case ('connected_with_orders')	:
						case ('connected_with_reverses'):
						case ('connected_with_deliverys'):
						case ('production_phase')	:
						case ('finished')		:
						case ('month')			:
						case ('month_part')		:
						case ('finisher')		:	$VALUE	=	$this->localize($VALUE, $COLUMN);
											break;
					}

					if ($COLUMN == 'personID')	{

						$this->TABLE_BODY .= "<td class=\"personID\">$VALUE&nbsp;&nbsp;</td>\n";

					}	else	  {

						$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					}
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"2\">\n";

				if ($this->CONT1) $this->TABLE_BODY .= "<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT1."&amp;id=$ID\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n";
				if ($this->CONT2) $this->TABLE_BODY .= "<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT2."&amp;id=$ID\">$CHANGE</a>&nbsp;&nbsp;&nbsp;\n";
				if ($this->CONT3) $this->TABLE_BODY .= "<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT3."&amp;id=$ID\">$DELETE</a>\n";

				$this->TABLE_BODY .= "</td>\n</tr>\n";
			}

			$this->SQL->free();

			unset($this->SQL->IT1_RESULT);
		}

		/**
		 * Read posts and set filter states
		 */
	
		private function GETPOST()	{

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				if (isset($_SESSION['LISTPAGE'])) $this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_SESSION['COMMAND'])) $this->COMMAND	= $_SESSION['COMMAND'];
		}
		
		/**
		 * Read additional arrays by need to memory
		 */
		 
		 private function READARRAYS()	{
		 
			foreach ($this->COLUMN_names as $COLUMN)	{
			
				switch($COLUMN)		{

					case ('delivery_form')		:	$__DELIVERYS		=	new DELIVERYloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->DELIVERY_TYPES	=	$__DELIVERYS->gettypes();
										
										break;

					case ('payment_form')		:	$__PAYMENTS		=	new PAYMENTloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->PAYMENT_TYPES	=	$__PAYMENTS->getnames();
										
										break;
										
					case ('production_phase')	:	$__PHASES		=	new PHASEloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->PHASES		=	$__PHASES->getall();

										break;
				}
			}
		 }

		/**
		 * Displays the table;
		 */

		public function create()	{
		
			$this->READARRAYS();

			$this->GETPOST();

			if (! $this->FORMCOMMAND()) return FALSE;

			$this->TABLEHEADER();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->TABLE_BODY);

			return TRUE;
		}
	}
?>
