<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 * eBag service usage (list of connected service lists)
	 */

	load_f('mb_wrap');

	class SERVICEUSAGE	{

		var $COLUMN_names	=	array(	'personID', 'contactname', 'city', 'date_of_creation', 'date_of_deadline', 'quantity', 'unit'	);

		var $COLUMN_names_AS	=	array();

		var $TABLE		=	'';

		function __construct()	{

			global $__SQL, $__CONF, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->LANG	=	&$__LANG;

			$this->BOX	=	&$__BOX;

			$this->BASE	=	$_SESSION['BASE'];

			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $_SESSION['BASE'];

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				if ($COLUMN == 'personID') $COLUMN = 'reversID';

				$this->COLUMN_names_AS[$COLUMN] = 	$this->LANG->get($COLUMN);
			}
		}


		private function readservice($ID)	{

			$this->SQL->query("	SELECT `code`, `servicename` as `name`, `unit` 
						FROM $this->STOCKBASE.services
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			$this->SERVICEDATA	=	$this->SQL->RESULT->fetch_assoc();

			$this->CODE		=	$this->SQL->r_escape($this->SERVICEDATA['code']);

			return TRUE;
		}

		public function create($ID)	{

			if (! $this->readservice($ID)) return 'unexistentservice';

			$this->TABLE	=	"<table class=\"list\">\n"
						.'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->TABLE .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->TABLE	.=	'</tr>'."\n";

			$this->SQL->query("	SELECT 	services_header.personID, services_header.contactname, services_header.city, 
							DATE_FORMAT(services_header.date_of_creation, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(services_header.date_of_deadline, '$this->FORMAT') AS `date_of_deadline`,
							services_data.quantity,
							services_data.unit
						FROM $this->BASE.services_header
						INNER JOIN $this->BASE.services_data
						ON services_header.personID = services_data.reversID
						WHERE  	services_data.code='$this->CODE' 
							AND services_header.date_of_finishing IS NULL 
							AND services_header.deleted IS NOT NULL
							AND services_data.deleted IS NOT NULL	
						ORDER BY services_header.personID ");
							
			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	return 'noserviceusage';
	
			$CLASS		=	'list-dark';
			
			$SUM		= 	0;

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					$this->TABLE .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					
					if ($COLUMN == 'quantity') $SUM += $VALUE;
				}

				$this->TABLE .=	"</tr>\n";
			}
			
			$this->SERVICEDATA['sum'] = $SUM;

			$this->SQL->free();

			$this->TABLE .= '</table>'."\n";

			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n$this->TABLE\n</div>\n</div>\n";

			return TRUE;
		}
	}
?>
