<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag creates table for order to stock from production orderID
	 */

	include('../functions/mb_wrap.php');

	class STOCKORDER2PRODUCTION	{

		function __construct()	{

			global $__SQL, $__LANG, $__BOX;

			$this->SQL		=	&$__SQL;

			$this->LANG		=	&$__LANG;
			
			$this->BOX		=	&$__BOX;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->FEEDSTOCKS_TABLE	=	FALSE;
			
			$this->ARTICLES_TABLE	=	FALSE;
			
			$this->ARTICAL_QUANTITY	=	0;
			
			$this->INC		=	0;
		}
		
		public function create($productionorderID)	{
		
			if ($this->PRODUCTION_ORDER_ID = $productionorderID)	{
			
				$this->read_artical_quantity();
				
				if ($this->ARTICAL_QUANTITY) $this->create_tables();
			}
			
			if ((! $this->ARTICLES_TABLE) && (! $this->FEEDSTOCKS_TABLE)) return FALSE;
			
			return TRUE;
		}
		
		public function read_artical_quantity()	{
		
			$this->SQL->query("	SELECT `quantity` 
						FROM $this->BASE.production_orders_header 
						WHERE `personID`='$this->PRODUCTION_ORDER_ID' AND `deleted` IS NOT NULL LIMIT 1	");
			
			if ($this->SQL->num_rows())	{
			
				$RESULT	= $this->SQL->RESULT->fetch_row();

				$this->ARTICAL_QUANTITY = $RESULT[0];
			}
		}

		private function create_tables()	{

			$this->SQL->query("	SELECT	production_orders_data.code, production_orders_data.name, production_orders_data.unit,
						(production_orders_data.quantity * $this->ARTICAL_QUANTITY) as on_order_quantity,
						(feedstock.quantity+(production_orders_data.quantity*$this->ARTICAL_QUANTITY)) AS stock_quantity, 
						feedstock.quantity_ordered_to_stock AS ordered_to_stock, 
						feedstock.quantity_on_opened_order_to_stock AS on_opened_order_to_stock,
				 		(feedstock.quantity_in_production-(production_orders_data.quantity*$this->ARTICAL_QUANTITY)) AS in_production,
				 		'-' AS requested_as_part
						FROM $this->BASE.production_orders_data INNER JOIN $this->STOCKBASE.feedstock
						ON production_orders_data.code=feedstock.code
						WHERE production_orders_data.productionorderID='$this->PRODUCTION_ORDER_ID'
						AND production_orders_data.type='f'
						AND production_orders_data.deleted IS NOT NULL
						AND feedstock.deleted IS NOT NULL
						ORDER BY production_orders_data.personID	");
						
			$this->SQL->RESULT_FEEDSTOCKS = $this->SQL->RESULT;

			$this->NUMROWS_FEEDSTOCKS = $this->SQL->num_rows();

			# Note:	the quantity in production is always 0 because product are not ordered
		
			$this->SQL->query("	SELECT	production_orders_data.code, production_orders_data.name, production_orders_data.unit,
						(production_orders_data.quantity * $this->ARTICAL_QUANTITY) as on_order_quantity,
						finished_goods_stock.quantity AS stock_quantity,
						finished_goods_stock.quantity_ordered AS ordered_from_stock,
						finished_goods_stock.quantity_ordered_to_stock AS ordered_to_stock,
						finished_goods_stock.quantity_on_opened_order_to_stock AS on_opened_order_to_stock,
						finished_goods_stock.quantity_as_part AS requested_as_part
						FROM $this->BASE.production_orders_data INNER JOIN $this->STOCKBASE.finished_goods_stock
						ON production_orders_data.code=finished_goods_stock.code
						WHERE production_orders_data.productionorderID='$this->PRODUCTION_ORDER_ID'
						AND production_orders_data.type='a'
						AND production_orders_data.deleted IS NOT NULL
						AND finished_goods_stock.origin!=1
						AND finished_goods_stock.deleted IS NOT NULL
						ORDER BY production_orders_data.personID	");
						
			$this->SQL->RESULT_ARTICLES = $this->SQL->RESULT;

			$this->NUMROWS_ARTICLES = $this->SQL->num_rows();
			
			if ($this->NUMROWS_FEEDSTOCKS)	{
			
				$COLUMNS	=	array(	$this->LANG->get('code'), 
								$this->LANG->get('articalname'), 
								$this->LANG->get('unit'), 
								$this->LANG->get('on_production_order_quantity'),
								$this->LANG->get('stock_quantity'), 
								$this->LANG->get('quantity_ordered_to_stock'), 
								$this->LANG->get('on_opened_order_to_stock'), 
								$this->LANG->get('quantity_in_production'), 
								$this->LANG->get('quantity_as_part'), 
								$this->LANG->get('to_order')	);
				
				$this->FEEDSTOCKS_TABLE = $this->write_table('f', $COLUMNS, $this->SQL->RESULT_FEEDSTOCKS);
			}
			
			unset($this->SQL->RESULT_FEEDSTOCKS);
			
			if ($this->NUMROWS_ARTICLES)	{
			
				$COLUMNS	=	array(	$this->LANG->get('code'), 
								$this->LANG->get('articalname'), 
								$this->LANG->get('unit'), 
								$this->LANG->get('on_production_order_quantity'),
								$this->LANG->get('stock_quantity'), 
								$this->LANG->get('ordered_from_stock'),
								$this->LANG->get('quantity_ordered_to_stock'), 
								$this->LANG->get('on_opened_order_to_stock'), 
								$this->LANG->get('quantity_as_part'), 
								$this->LANG->get('to_order')	);
								
				$this->ARTICLES_TABLE = $this->write_table('a', $COLUMNS, $this->SQL->RESULT_ARTICLES);
			}
			
			unset($this->SQL->RESULT_ARTICLES);
		}
		
		private function write_table($type, $COLUMNS, $SQL_RESOURCE)	{
		
			$table_is_empty = TRUE;
		
			$TABLE = '';
		
			# create table header

			$TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\"><tr class=\"list-column-names\">\n";

			foreach ($COLUMNS as $NAME) $TABLE .= '<td>'.mb_wrap($NAME, 1, '<br>').'</td>'."\n";

			$TABLE	.=	'</tr>'."\n";

			# create table body

			$CLASS		=	'list-dark';

			while ($RESULT = $SQL_RESOURCE->fetch_assoc())	{
	
				# Determine quantity to order
			
				if ($type == 'f')	{
			
					# note: quantity in production is defined before, now we calculating only with now ordered quantity (for feedstocks)

					$difference = 0 -($RESULT['stock_quantity'] + $RESULT['ordered_to_stock'] + $RESULT['on_opened_order_to_stock'] - $RESULT['on_order_quantity'] );
				
				} 	else	  {
				
					$difference = 0 - ($RESULT['stock_quantity'] + $RESULT['ordered_to_stock'] + $RESULT['on_opened_order_to_stock'] - $RESULT['on_order_quantity'] - $RESULT['ordered_from_stock'] - $RESULT['requested_as_part']);
				}
				
				if ($difference <= 0) continue;
				
				$table_is_empty = FALSE;
				
				# write the table

				if ($CLASS=='list-dark') {$CLASS = 'list-light';} else {$CLASS = 'list-dark';}
				
				$TABLE .=	"<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";
				
				foreach ($RESULT as $COLUMN=>$VALUE)	{
				
					if (($COLUMN != 'code') && ($COLUMN != 'name') && ($COLUMN != 'unit'))	{

						if ($VALUE != '-') $VALUE = number_format($VALUE , 2, '.', '');
						
						# Using the same size for quantities to get same tables
						
						$boxsize = 90;
						
					}	else	{
					
						$boxsize = $this->BOX->size($COLUMN);
					}
					
					if ($COLUMN == 'unit')	{$type_tag = '<input name="type[]" type="hidden" value="'.$type.'">';} else {$type_tag = '';}

					$TABLE .= '<td><input name="'.$COLUMN.'[]" class="list-input" style="width: '.$boxsize.'px;" readonly value="'.$VALUE.'" onkeypress="return nextfield(this, event, \'to_order_'.$this->INC.'\');">'.$type_tag.'</td>'."\n";
				}		

				# additional input for quantity

				$FIELDID	=	"to_order_$this->INC";

				if ($this->INC == ($this->NUMROWS_FEEDSTOCKS + $this->NUMROWS_ARTICLES-2))	{

					$NEXTFIELD = 'return nextfield(this,event, \'submit\');';

				}	else	  {

					$this->INC++;

					$NEXTFIELD = "return nextfield(this,event, 'to_order_$this->INC');";
				}
				
				$difference =  number_format($difference , 2, '.', '');

				$TABLE .= "<td><input id=\"$FIELDID\" name=\"order[]\" class=\"search-box\" style=\"width: ".$this->BOX->size('difference')."px;\" value=\"$difference\" onkeypress=\"$NEXTFIELD\"></td>\n";

				$TABLE .= '</tr>'."\n";
			}

			$TABLE	.= '</table></div></div>'."\n";
			
			if (! $table_is_empty) return $TABLE;
			
			return '';
		}
	}
?>

