<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag TABLE with FILTERS class
	 */

	load_f('pagination');
	load_f('mb_wrap');

	class TABLE	{
	
		var $COLUMN_names	=	array();
		var $COLUMN_names_AS	=	array();
		var $FILTER_type	=	array();
		var $FILTER_state	=	array();
		var $TABLE		=	'';
		var $ROW_FILTER		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COLUMNS		=	FALSE;
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $SORT		=	'cadc8c8db42409733582cb3e2298ef87';
		var $COMMAND		=	'';
		var $customerID		=	FALSE;

		/**
		 * Sets the table
		 */

		function __construct($TABLE, $CONTROLLER1, $CONTROLLER2, $CONTROLLER3, $INCREMENT, $LIMIT)	{

			$this->SQLTABLE	=	$TABLE;
			$this->CONT1	=	$CONTROLLER1; // details
			$this->CONT2	=	$CONTROLLER2; // edit
			$this->CONT3	=	$CONTROLLER3; // delete
			$this->INC	=	$INCREMENT;
			$this->LIMIT	=	$LIMIT;
			$this->BASE	=	$_SESSION['BASE'];

			global $__SQL, $__LANG, $__BOX, $__CONF;

			$this->SQL	=	&$__SQL;
			$this->LANG	=	&$__LANG;
			$this->BOX	=	&$__BOX;
			$this->CONF	=	&$__CONF;
			
			$this->CHARS_FLAG = 	$__CONF->get('specialchars','flag');

			unset($_SESSION['ID']);
			
			$this->WHERE	=	'';
			$this->ORDERBY	=	'';
		}

		/**
		 * Sets the columns to display basename, displayname, filter type
		 * (Filter types : none, box, listbox, static, numeric, date)
		 */
		
		public function column($COLUMN, $FILTER='none', $RENAME=FALSE)	  {

			array_push($this->COLUMN_names, $COLUMN);
			
			$this->FILTER_type[$COLUMN]	=	$FILTER;

			$this->COLUMN_names_AS[$COLUMN] =	$this->LANG->get($COLUMN);
			
			if ($RENAME) $this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($RENAME);

			if ($FILTER != 'none') $this->FILTER_state[$COLUMN] = FALSE;
		}

		/**
		 * Adds customer to lists (summarys)
  		 */

		public function customerID($ID)	{
		
			$this->customerID	=	$ID;
		}

		/**
		 * Adds filter to where clausule
		 */

		public function addwhere($FILTER)	{

			if (! $this->WHERE) {$AND = ' WHERE ';} else {$AND = ' AND ';}

			$this->WHERE .= " $AND $FILTER ";
		}

		/**
		 * Adds filter to order by clausule
		 */

		public function addorderby($FILTER)	{

			if (! $this->ORDERBY)	{$AND =	' ORDER BY ';} else {$AND = ' , ';}

			$this->ORDERBY .= " $AND $FILTER ";
		}

		/**
		 * Adds columns to search
		 */

		private function addcolumn($COLUMN)	{

			if ($this->FILTER_type[$COLUMN]=='date')	{

				$COLUMN = "DATE_FORMAT(`$COLUMN`, '".$this->CONF->get('date', 'sql_format')."') AS `$COLUMN`";
			}	else	{

				$COLUMN = "`$COLUMN`";
			}

			if (! $this->COLUMNS) {$this->COLUMNS = $COLUMN;} else {$this->COLUMNS .= ", $COLUMN";}
		}
		
		/**
		 * Forms command with where and order by clausules
		 */

		private function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				$COLUMNS	=	'';

				foreach ($this->COLUMN_names as $COLUMN) $this->addcolumn($COLUMN);
			
				$this->COMMAND	=	"SELECT SQL_CALC_FOUND_ROWS $this->COLUMNS FROM $this->SQLTABLE";

				unset($this->COLUMNS);

				# note: special cases claims, and customer (summaryes)

				if (strpos($this->SQLTABLE, '.claims') !== FALSE) $this->addorderby('`date_of_creation`');

				if ($this->customerID) $this->addwhere("`contactID`='$this->customerID'");

				# others by POSTS

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((! isset($this->FILTER_state[$COLUMN])) or ((! $this->FILTER_state[$COLUMN]) && (! is_numeric($this->FILTER_state[$COLUMN])))) continue;

					switch($this->FILTER_type[$COLUMN])		{

						case ('box')	:	# finishers special case where must to query for getting the id first

									if ($COLUMN == 'finisher')	{

										$SEARCHED = array();

										$SEARCHED_STR	=	$this->SQL->s_escape($this->FILTER_state[$COLUMN], 'REGEXP');

										$this->SQL->query("	(SELECT `personID`, ('cooperator') AS `type` FROM $this->BASE.addressbook WHERE `contactname` REGEXP '$SEARCHED_STR' AND `contacttype`='4' AND `deleted` IS NOT NULL)
													UNION ALL
													(SELECT `personID`, ('employee') AS `type` FROM $this->BASE.employees WHERE `employeename` REGEXP '$SEARCHED_STR' AND DELETED IS NOT NULL)");

										if ($this->SQL->num_rows())	{

											while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{
	
												$FOUND = "'".$RESULT['type'].'_'.$RESULT['personID']."'";

												if (! isset($IN)) {$IN = $FOUND;} else {$IN .= ", $FOUND";}
											}

											$this->addwhere("`$COLUMN` IN ($IN)");

										}	else	  {

											# not possible, used to not get result
	
											$this->addwhere("`$COLUMN`='1' AND `$COLUMN`='2'");
										}

										break;
									}
									
									# tax specail case
									
									if ($COLUMN == 'tax')	{
									
										$this->addwhere("`$COLUMN`=".$this->SQL->n_escape($this->FILTER_state[$COLUMN]));
										break;
									}

									if (($COLUMN == 'connected_with_orders') or 
									    ($COLUMN == 'connected_with_deliverys') or 
									    ($COLUMN == 'connected_with_reverses'))	{

										$this->addwhere("`$COLUMN` REGEXP '-".($this->SQL->s_escape($this->FILTER_state[$COLUMN], 'REGEXP'))."-'");
										break;
									}

									# default box case

									$this->addwhere("`$COLUMN` REGEXP '".($this->SQL->s_escape($this->FILTER_state[$COLUMN], 'REGEXP'))."'");
									break;

						case('listbox')	:
						case('static')	:	if ($this->FILTER_state[$COLUMN] == $this->SORT)	{

										$this->addorderby("`$COLUMN`");
										break;
									}

									$this->addwhere("`$COLUMN`='".($this->SQL->escape($this->FILTER_state[$COLUMN]))."'");
									break;

						case('numeric')	:	if ($this->FILTER_state[$COLUMN] == $this->SORT)	{

										$this->addorderby("`$COLUMN`");
										break;
									}

									$this->addwhere($COLUMN.html_entity_decode($this->FILTER_state[$COLUMN], ENT_COMPAT, 'UTF-8'));
									break;

						case('date')	:	$DATE	= 	explode('/', $this->FILTER_state[$COLUMN]);

									if ($DATE[0]!='-') $this->addwhere(" DAY($COLUMN)=".$DATE[0]);

									if ($DATE[1]!='-') $this->addwhere(" MONTH($COLUMN)=".$DATE[1]);

									if ($DATE[2]!='-') $this->addwhere(" YEAR($COLUMN)=".$DATE[2]);

									unset($DATE);

									break;
					}
				}

				$PREFIX	= 'AND';

				if (! $this->WHERE)	$PREFIX = 'WHERE';

				$this->COMMAND .= $this->WHERE." $PREFIX `deleted` IS NOT NULL ";
				
				# add default ordering by personID if the column exists & other is not defined
				
				if ((! $this->ORDERBY) && (in_array('requestID', $this->COLUMN_names)))	{
				
					 $this->addorderby("`requestID`");
					 
					 if (in_array('personID', $this->COLUMN_names)) $this->addorderby("`personID`");
				}
				
				if ((! $this->ORDERBY) && (in_array('personID', $this->COLUMN_names))) $this->addorderby("`personID`");

				if ($this->ORDERBY)	$this->COMMAND .= $this->ORDERBY;

				$_SESSION['COMMAND'] 	=	$this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Localize the data readed from base
		 */

		private function localize($VALUE, $COLUMN)	{

			switch($COLUMN)		{
			
				case('orderID')			:	if ($VALUE) {$TXT = $VALUE;} else {$TXT = '-';}
									break;

				case('contacttype')		:	$TXT = $this->LANG->get("type$VALUE");
									break;

				case('delivery_day_of_week')	:	$TXT = $this->LANG->get("day$VALUE");
									break;

				case('critic')			:	$TXT = $this->LANG->get("critic$VALUE");
									break;

				case('origin')			:	$TXT = $this->LANG->get("origin$VALUE");
									break;

				case ('delivery_form')		:	$TXT		=	'';

									if (isset($this->DELIVERY_TYPES[$VALUE]))	$TXT = $this->DELIVERY_TYPES[$VALUE];

									break;

				case ('payment_form')		:	$TXT		=	'';

									if (isset($this->PAYMENT_TYPES[$VALUE]))	$TXT = $this->PAYMENT_TYPES[$VALUE];
							
									break;

				case ('production_phase')	:	$TXT	=	'';

									if (isset($this->PHASES[$VALUE]))	$TXT = $this->PHASES[$VALUE];
								
									break;

				case('delivered')		:	$TXT = $this->LANG->get("deliverystate$VALUE");
									break;

				case('ordered')			:
				case('billed')			:
				case('finished')		:	$TXT = $this->LANG->get("yesno$VALUE");
									break;
				case ('connected_with_deliverys'):
				case ('connected_with_reverses'):
				case ('connected_with_orders')	:	if (is_empty($VALUE))	{

										$TXT = $VALUE;
										break;
									}

									$LIST	=	explode('-', $VALUE);

									unset($LIST[count($LIST)-1], $LIST[0]);

									$TXT	=	implode(',', $LIST);

									break;

				case('finisher')		:	if (! $VALUE)	{

										$TXT = $VALUE;
										break;
									}

									list($TYPE, $FINISHERID)	=	explode('_', $VALUE);

									if ($TYPE == 'employee')	{

										$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

									}	else	   {

										$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
									}

									$this->SQL->query($COMMAND);

									if ($this->SQL->num_rows())	{

										list($TXT) = $this->SQL->RESULT->fetch_row();

									}	else	 {

										$TXT = $this->LANG->get('finisherwasdeleted');
									}

									break;

				case('month')			:	$TXT = $this->LANG->get("monthname$VALUE");
									break;
									
				case('month_part')		:	if ($VALUE == 1) {$TXT = 'I';} elseif ($VALUE == 2) {$TXT = 'II';} else {$TXT = 'I-II';}
									break;


				default				:	$TXT = $VALUE;
			}

			return $TXT;
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 5, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input name="PRINT" class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	'</tr>'."\n";
		}

		/**
		 * Create tabe row with filters
		 */
		 
		private function select_generic_options($COLUMN)	{

			$this->ROW_FILTER .= "<td>\n<select style=\"width: ".$this->BOX->size($COLUMN)."px;\" name=\"$COLUMN\">\n";

			// the all will be empty=>false

			if ($this->FILTER_state[$COLUMN]===FALSE) {$selected='selected';} else {$selected='';}

			$this->ROW_FILTER .= "<option $selected value=\"\">".$this->LANG->get('all')."</option>\n";

			if ($this->FILTER_state[$COLUMN] == $this->SORT)  {$selected='selected';} else {$selected='';}

			$this->ROW_FILTER .= "<option $selected value=\"$this->SORT\">".$this->LANG->get('sort')."</option>\n";
		}
		
		private function is_selected($COLUMN, $VALUE)	{
		
			if (($this->FILTER_state[$COLUMN]!==FALSE) && (htmlspecialchars($this->FILTER_state[$COLUMN], $this->CHARS_FLAG, 'UTF-8', FALSE)==$VALUE)) return 'selected';
			
			return '';
		}

		private function TABLEFILTERS()	{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$VALUE	=	'';

				if ($this->FILTER_type[$COLUMN]=='none') $this->ROW_FILTER .= '<td></td>'."\n";

				/**
				 * Adds listbox
				 */

				if ($this->FILTER_type[$COLUMN]=='listbox')	{

					$this->SQL->query("SELECT `$COLUMN` FROM $this->SQLTABLE WHERE `$COLUMN` IS NOT NULL AND `deleted` IS NOT NULL GROUP BY `$COLUMN`");

					if ($this->SQL->num_rows() > $this->LIMIT)	{

						$this->FILTER_type[$COLUMN]='box';

					}	else	  {

						$this->select_generic_options($COLUMN);

						while (list($VALUE) = $this->SQL->RESULT->fetch_row())	{

							if ((! $VALUE) && (! is_numeric($VALUE))) continue;

							$TXT = $this->localize($VALUE, $COLUMN);

							// todo : browser depending cut of length if (mb_strlen($TXT, 'UTF-8') > 14) $TXT=mb_substr($TXT, 0, 12, 'UTF-8').'..';

							$this->ROW_FILTER .= '<option '.$this->is_selected($COLUMN, $VALUE)." value=\"$VALUE\">$TXT</option>\n";
						}

						$this->SQL->free();

						$this->ROW_FILTER .=  "</select>\n</td>\n";
					}
				}
				
				/**
				 * Adds static list or numeric list box
				 */
				 
				if (($this->FILTER_type[$COLUMN]=='numeric') or ($this->FILTER_type[$COLUMN]=='static'))	{
				
					if ($this->FILTER_type[$COLUMN]=='numeric')	{
					
						$VALUE_SET[$COLUMN] = array('!=0', '=0', '&lt;0', '&lt;10', '&lt;20', '&lt;30', '&lt;50', '&lt;100', '&lt;500', '&lt;1000');
						
					}	else	  {
								
						switch($COLUMN)		{
						
							case('month')			:	$VALUE_SET[$COLUMN] = range(1,12);
							
												break;

							case('delivered')		:
							case('month_part')		:	$VALUE_SET[$COLUMN] = range(0,2);
							
												break;
											
							case('delivery_day_of_week')	:	$VALUE_SET[$COLUMN] = array(1,2,3,4,5,6,0);
							
												break;
												
							case('contacttype')		:	$VALUE_SET[$COLUMN] = range(0,5);
							
												break;
							case('ordered')			:
							case('finished')		:
							case('critic')			:
							case('billed')			:	$VALUE_SET[$COLUMN] = array(0,1);
							
												break;

							case ('delivery_form')		:	$VALUE_SET[$COLUMN]	=	array_keys($this->DELIVERY_TYPES);

												break;

							case ('payment_form')		:	$VALUE_SET[$COLUMN]	=	array_keys($this->PAYMENT_TYPES);

												break;
												
							case ('production_phase')	:	$VALUE_SET[$COLUMN]	=	array_keys($this->PHASES);

												break;
											  
							case ('unit')			:	$VALUE_SET[$COLUMN]	=	$this->UNITS;

												break;
						}
					}
					
					$this->select_generic_options($COLUMN);
					
					foreach ($VALUE_SET[$COLUMN] as $VALUE)	{

						$TXT = $VALUE = "$VALUE";

						if ((! $VALUE) && (! is_numeric($VALUE))) continue;

						if (($this->FILTER_type[$COLUMN]=='static') && ($COLUMN != 'unit')) $TXT = $this->localize($VALUE, $COLUMN);

						$this->ROW_FILTER .= '<option '.$this->is_selected($COLUMN, $VALUE)." value=\"$VALUE\">$TXT</option>\n";
					}

					$this->ROW_FILTER .=  "</select>\n</td>\n";
				}
				
				/**
				 * Adds simple input box or date box
				 */

				if (($this->FILTER_type[$COLUMN] == 'box') or ($this->FILTER_type[$COLUMN] == 'date'))	{

					if ($this->FILTER_type[$COLUMN] == 'date')	{

						if ($this->FILTER_state[$COLUMN])	{

							$DATE	=	explode('/', $this->FILTER_state[$COLUMN]);

							if ($DATE[0] != '-') {$DATE[0]='d'.$DATE[0];} else {$DATE[0]='';}
							if ($DATE[1] != '-') {$DATE[1]='m'.$DATE[1];} else {$DATE[1]='';}
							if ($DATE[2] != '-') {$DATE[2]='y'.$DATE[2];} else {$DATE[2]='';}

							$VALUE	= $DATE[0].$DATE[1].$DATE[2];
						}

					}	else	{

						$VALUE	= $this->FILTER_state[$COLUMN];
						
						# for any case encode double quote to not break html_entity_decode
						
						if (stripos($VALUE, '"') !== FALSE) $VALUE = mb_eregi_replace('"', '&quot;', $VALUE);
					}

					$this->ROW_FILTER .= "<td>\n<input class=\"filter-input\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

					unset($DATE);
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');
			$CHANGE		=	$this->LANG->get('change');
			$DELETE		=	$this->LANG->get('delete');

			if ((stripos($this->SQLTABLE, 'suplie_request_data')!==FALSE) or (stripos($this->SQLTABLE, 'feedstock_requests')!==FALSE))  $SUPLIEREQUEST = TRUE;

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					switch ($COLUMN)	{

						case ('personID')		:	$ID	=	$VALUE;

											break;

						case ('requestID')		:	if (isset($SUPLIEREQUEST))	$ID = $VALUE;

											break;
						case ('orderID')		:
						case ('contacttype')		:
						case ('delivery_day_of_week')	:
						case ('finished')		:
						case ('ordered')		:
						case ('connected_with_deliverys'):
						case ('connected_with_reverses'):
						case ('connected_with_orders')	:
						case ('finisher')		:
						case ('ordered')		:
						case ('delivered')		:
						case ('delivery_form')		:
						case ('payment_form')		:
						case ('billed')			:
						case ('production_phase')	:
						case ('month')			:
						case ('month_part')		:
						case ('critic')			:	$VALUE	=	$this->localize($VALUE, $COLUMN);
											break;
					}

					if ($COLUMN == 'personID')	{

						$this->TABLE_BODY .= "<td class=\"personID\">$VALUE&nbsp;&nbsp;</td>\n";

					}	else	  {

						$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					}
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"2\">\n";

				if ($this->CONT1) $this->TABLE_BODY .= "<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT1."&amp;id=$ID\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n";
				if ($this->CONT2) $this->TABLE_BODY .= "<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT2."&amp;id=$ID\">$CHANGE</a>&nbsp;&nbsp;&nbsp;\n";
				if ($this->CONT3) $this->TABLE_BODY .= "<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT3."&amp;id=$ID\">$DELETE</a>\n";

				$this->TABLE_BODY .= "</td>\n</tr>\n";
			}

			unset($this->SQL->IT1_RESULT);

			$this->SQL->free();
		}

		/**
		 * Read posts and set filter states
		 */
	
		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}
		

			if (isset($_POST['FILTER']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = 0;

				foreach ($this->COLUMN_names as $COLUMN)	{

					if (isset($_POST[$COLUMN]))	{

						if ($this->FILTER_type[$COLUMN]=='date')	{

							if (! function_exists('date2search')) load_f('date2search');

							$this->FILTER_state[$COLUMN] = date2search($_POST[$COLUMN], $this->LANG->get('datesearchdaysign'), $this->LANG->get('datesearchmonthsign'), $this->LANG->get('datesearchyearsign'));

						}	else	  {

							$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];

						}
					}
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state 	=	$_SESSION['FILTERS'];
				if (isset($_SESSION['COMMAND'])) $this->COMMAND		=	$_SESSION['COMMAND'];
			}
		}
		
		/**
		 * Read additional arrays by need to memory
		 */
		 
		 private function READARRAYS()	{
		 
			foreach ($this->COLUMN_names as $COLUMN)	{
			
				switch($COLUMN)		{
				
					case ('delivery_form')		:	$__DELIVERYS		=	new DELIVERYloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->DELIVERY_TYPES	=	$__DELIVERYS->gettypes();
										
										break;

					case ('payment_form')		:	$__PAYMENTS		=	new PAYMENTloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->PAYMENT_TYPES	=	$__PAYMENTS->getnames();
										
										break;
										
					case ('production_phase')	:	$__PHASES		=	new PHASEloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->PHASES		=	$__PHASES->getall();

										break;
										
					case ('unit')			:	$__UNITS		=	new UNITloader($this->CONF->get('cache', 'use_apc_cache'));

										$this->UNITS		=	$__UNITS->getall();
										
										break;
				}
			}
		 }

		/**
		 * Displays the table;
		 */

		public function create()	{
		
			$this->READARRAYS();

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);
		}
	}

?>
