<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag timing search class
	 */

	load_f('pagination');
	load_f('mb_wrap');

	class TIMING	{

		var $COLUMN_names	=	array();
		var $COLUMN_names_AS	=	array();
		var $TABLE		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COMMAND		=	'';
		var $COLUMNS		=	'';
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $DATES		=	array('date', 'date_of_creation', 'date_of_deadline', 'date_of_finishing', 'date_of_employment');

		function __construct($TABLE, $NEWLINK, $CONTROLLER1, $CONTROLLER2, $CONTROLLER3, $INCREMENT, $LIMIT)	{

			$this->SQLTABLE	=	$TABLE;
			$this->NEWLINK	=	$NEWLINK;
			$this->CONT1	=	$CONTROLLER1;
			$this->CONT2	=	$CONTROLLER2;
			$this->CONT3	=	$CONTROLLER3;
			$this->INC	=	$INCREMENT;
			$this->LIMIT	=	$LIMIT;
			$COMMAND	=	'';
			$PAGE		=	0;
	
			global $__SQL, $__LANG, $__BOX, $__CONF;

			$this->SQL	=	&$__SQL;
			$this->LANG	=	&$__LANG;
			$this->BOX	=	&$__BOX;
			$this->CONF	=	&$__CONF;
			$this->BASE	=	$_SESSION['BASE'];
			
			$__DELIVERYS = new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'));

			$this->DELIVERY_TYPES = $__DELIVERYS->gettypes();

			unset($_SESSION['ID'], $__DELIVERYS);
		}

		/**
		 * Sets the columns to display
		 */
		
		public function column($COLUMNS)	{

			if (! is_array($COLUMNS)) $COLUMNS=array($COLUMNS);

			foreach ($COLUMNS as $COLUMN)	{

				array_push($this->COLUMN_names, $COLUMN);
			
				$this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($COLUMN);
			}
		}

		/**
		 * Sets searched items
		 */

		public function addsearch($POST)	{

			$this->ITEMS	=	$POST;
		}

		/**
		 * Return current tablename (from base.table)
	 	 */

		private function gettable()	{

			$array = explode('.', $this->SQLTABLE);
			return $array[1];
		}
	
		/**
		 * Adds filter command
		 */

		private function addfilter($FILTER)	{

			if (! $this->WHERE) {$AND = ' WHERE ';} else {$AND = ' AND ';}

			$this->WHERE .= " $AND $FILTER ";
		}

		/**
		 * Adds columns to search
		 */

		private function addcolumn($COLUMN)	{

			if (in_array($COLUMN, $this->DATES))	{

				$COLUMN = "DATE_FORMAT(`$COLUMN`, '".$this->CONF->get('date', 'sql_format')."') AS `$COLUMN`";
			}	else	{

				$COLUMN = "`$COLUMN`";
			}

			if (! $this->COLUMNS) {$this->COLUMNS = $COLUMN;} else {$this->COLUMNS .= ", $COLUMN";}
		}


		/**
		 * Gets the searched post array & forms sql command;
	 	 */

		public function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				foreach ($this->COLUMN_names as $COLUMN) $this->addcolumn($COLUMN);

				$this->WHERE	=	'';

				foreach ($this->ITEMS as $BOX=>$VALUE)		{

					if ((strpos($BOX, '_value')!==FALSE) && (! is_empty($VALUE)))	  {

						$VALUE	=	(integer)$VALUE;

						$PARTS	=	explode('_', $BOX);

						$COUNT	=	count($PARTS)-1;

						$TYPE	=	strtoupper($PARTS[$COUNT-1]);

						$SIGN	=	html_entity_decode($this->ITEMS[str_replace('_value', '', $BOX)], ENT_COMPAT, 'UTF-8');

						unset($PARTS[$COUNT], $PARTS[$COUNT-1]);

						$BOX	=	implode('_', $PARTS);

						if (! is_empty($SIGN)) $this->addfilter(" $TYPE ($BOX)".$SIGN.$VALUE);

					}
				}

				if (! $this->WHERE) return FALSE;
				
				if (in_array('personID', $this->COLUMN_names)) {$ORDERBY = ' ORDER BY `personID` ';} else {$ORDERBY = '';}

				$this->COMMAND	=	"SELECT SQL_CALC_FOUND_ROWS $this->COLUMNS FROM $this->SQLTABLE";

				$this->COMMAND .= 	$this->WHERE." AND `deleted` IS NOT NULL ".$ORDERBY;
				

				$_SESSION['COMMAND']	=	$this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;

			return TRUE;
		}

		/**
		 * Localize the data readed from base
		 */

		private function localize($VALUE, $COLUMN)	{

			switch($COLUMN)		{

				case('contacttype')		:	$TXT = $this->LANG->get("type$VALUE");
									break;

				case('delivery_day_of_week')	:	$TXT = $this->LANG->get("day$VALUE");
									break;

				case('critic')			:	$TXT = $this->LANG->get("critic$VALUE");
									break;

				case('origin')			:	$TXT = $this->LANG->get("origin$VALUE");
									break;

				case('finished')		:	$TXT = $this->LANG->get("yesno$VALUE");
									break;

				case('delivered')		:	$TXT = $this->LANG->get("deliverystate$VALUE");
									break;

				case ('delivery_form')		:	$TXT = '';

									if (isset($this->DELIVERY_TYPES[$VALUE]))  $TXT = $this->DELIVERY_TYPES[$VALUE];

									break;

				case('finisher')		:	if (is_empty($VALUE))	{

										$TXT = $VALUE;
										break;
									}

									list($TYPE, $FINISHERID)	=	explode('_', $VALUE);

									if ($TYPE == 'employee')	{

										$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

									}	else	   {

										$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
									}

									$this->SQL->query($COMMAND);

									if ($this->SQL->num_rows())	{

										$RESULT	= $this->SQL->RESULT->fetch_row();
										$TXT = $RESULT[0];

									}	else	 {

										$this->LANG->get('finisherwasdeleted');
									}

									break;

				default				:	$TXT = $VALUE;
			}

			return $TXT;
		}

		/**
		 * Create table header row
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				$CLASS	=	'';

				if ($key == 'personID') {$CLASS = 'class="personID-search"';}	else	{$CLASS = 'class="column-search"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";
			}

			$this->ROW_LABEL	.=	'<td class="filters">'."\n"
						 	."<input name=\"NEW\" class=\"button-list\" type=\"button\" onclick=\"Javascript: location.href='loader.php?cat=$this->NEWLINK&amp;new=1'\" value=\"".$this->LANG->get('newsearch').'">'."\n"
							.'</td><td class="filters">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	"</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else	  { 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM	=	floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');
			$CHANGE		=	$this->LANG->get('change');
			$DELETE		=	$this->LANG->get('delete');

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $key=>$COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					switch ($COLUMN)	{

						case ('personID')		:	$ID	=	$VALUE;
											break;
						case ('type')			:
						case ('delivery_day_of_week')	:
						case ('critic')			:
						case ('origin')			:
						case ('delivered')		:
						case ('delivery_form')		:
						case ('finished')		:
						case('contacttype')		:
						case ('finisher')		:	$VALUE	=	$this->localize($VALUE, $COLUMN);
											break;
					
					}

					if ($COLUMN == 'personID')	{

						$this->TABLE_BODY .= "<td class=\"personID\">$VALUE&nbsp;&nbsp;</td>\n";

					}	else	  {

						$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					}
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"2\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT1."&amp;id=$ID\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n"
						    	."<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT2."&amp;id=$ID\">$CHANGE</a>&nbsp;&nbsp;&nbsp;\n"
						    	."<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT3."&amp;id=$ID\">$DELETE</a>\n"
							."</td>\n";

				$this->TABLE_BODY .= "</tr>\n";
			}

			$this->SQL->free();

			unset($this->SQL->IT1_RESULT);
		}

		/**
		 * Read posts and set filter states
		 */
	
		private function GETPOST()	{

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				if (isset($_SESSION['LISTPAGE'])) $this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_SESSION['COMMAND'])) $this->COMMAND	= $_SESSION['COMMAND'];
		}
		
		/**
		 * Read arrays from base
		 */
		 
		 private function READARRAYS()	{
		 
		 }

		/**
		 * Displays the table;
		 */

		public function create()	{
		
			$this->GETPOST();

			if (! $this->FORMCOMMAND()) return FALSE;

			$this->TABLEHEADER();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->TABLE_BODY);

			return TRUE;
		}
	}

?>
