<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag view processing engine (without cache)
	 */

	class View	{

		var $VARS	=	array();
		var $TPL	=	FALSE;
		var $CREATED	=	FALSE;
		var $FILE	=	FALSE;
		var $CACHE	=	FALSE;

		/**
		 * Sets view file
		 */

		function __construct($file)	{
		
			global $__HANDLER;
			
			$this->HANDLER = &$__HANDLER;

			$this->FILE = $file;
		}

		/**
		 * Assigns variable
		 */

		function assign($var, $val)	{

			$this->VARS[$var] = $val;
		}
		
		/**
		 * Set & read cache
		 */
		 
		function cache($suffix='')	{
		
			if ($suffix) $suffix = '_'.$suffix;
		
			$this->CACHE = '../tmp/c_view_'.$this->FILE.$suffix.'.tmp';
	
			if (is_readable($this->CACHE)) {include($this->CACHE); exit;}
		}

		/**
		 * Create the view 
		 */

		private function evaulate()	{

			ob_start();

			extract($this->VARS);
			
			include('../views/'.$this->FILE.'.php');
	
			$this->TPL = ob_get_contents();

			ob_end_clean();	
		}

		/**
		 * Prepare enviroment
		 */

		private function create()	{
		
			$this->HANDLER->NOTICESTEP = TRUE;

			$this->evaulate();
			
			$this->HANDLER->NOTICESTEP = FALSE;

			$this->CREATED = TRUE;
		}
	
		/**
		 * Returns the processed view
		 */

		function process()	{

			if (! $this->TPL) $this->create();
			
			return $this->TPL;
		}
		
		/**
		 * Display the processed view
		 */

		function display()	{

			if (! $this->TPL) $this->create();
			
			if (! $this->CACHE)	{

				header('Pragma: no-cache');
				header('Cache-Control: no-cache, no-store, must-revalidate');
				header('Expires: Sun, 10 Jan 2010 12:00:00 GMT');
				header('Last-Modified: '.@gmdate('D, d M Y H:i:s').' GMT');
			}
			
			echo $this->TPL;
			
			if ($this->CACHE) @file_put_contents($this->CACHE, $this->TPL);
		}
	}

?>
