<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag settings add, change or delete delivery form
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	if (	(isset($_POST['addnew'])) or 
		(isset($_POST['change'])) or 
		(isset($_POST['delete'])) or
		(isset($_POST['default'])))	{

		$SUBMITTED	=	base64_encode(serialize($_POST));

		# note: store submitted data temporary as id

		$view	=	new View('verify');
		$view	->	assign('SELF', backward());
		$view	->	assign('QUESTION', $__LANG->get('suretochangedelivery'));
		$view	->	assign('YES', $__LANG->get('yes'));
		$view	->	assign('NO', $__LANG->get('no'));
		$view	->	assign('ID', $SUBMITTED);
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;
	}

	load_c('SQL');

	$__SQL	= new SQL();
	
	if (isset($_POST['YES']))	{

		load_m('deliveryforms');

		$__DELIVERYS	=	new DELIVERYFORMS();

		$SUBMITTED	=	unserialize(base64_decode($_POST['id']));

		if (isset($SUBMITTED['addnew']))	{

			$RESULT	= $__DELIVERYS->addnew($SUBMITTED['newtext']);

		}	elseif (isset($SUBMITTED['change']))	{

			$RESULT = $__DELIVERYS->change($SUBMITTED['deliveryID'], $SUBMITTED['newtext']);

		}	elseif (isset($SUBMITTED['default']))	{

			$RESULT = $__DELIVERYS->defaultdelivery($SUBMITTED['deliveryID']);

		}	else	{

			$RESULT = $__DELIVERYS->delete($SUBMITTED['deliveryID']);
		}
	
		unset($__DELIVERYS);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		# reload the deliverys for all users
		# note: load($RELOAD = TRUE);

		$__DELIVERYS	=	new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'), TRUE);

		unset($__DELIVERYS, $__SQL);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('settingssaved'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	$__DELIVERYS	=	new DELIVERYloader($__CONF->get('cache', 'use_apc_cache'));

	$DELIVERY_FORMS		=	$__DELIVERYS->gettypes();

	unset($__DELIVERYS, $__SQL);

	$view	=	new View('delivery_forms');

	$view	->	assign('SELF', backward());
	$view	->	assign('DELIVERY_FORMS', $__LANG->get('delivery_forms'));
	$view	->	assign('DELIVERY_FORM', $__LANG->get('delivery_name'));
	$view	->	assign('NEW_NAME', $__LANG->get('newname'));
	$view	->	assign('SET_TO_DEFAULT', $__LANG->get('set_to_default'));
	$view	->	assign('ADDNEW', $__LANG->get('addnew'));
	$view	->	assign('CHANGE', $__LANG->get('change'));
	$view	->	assign('DELETE', $__LANG->get('delete'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');

	$view	->	assign('DELIVERYS', $DELIVERY_FORMS); unset($DELIVERY_FORMS);

	$view	->	display();

?>
