<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service selector for feedstock request for services (new & change & delete);
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('services');

	pagepermission('services', 'w'); 

	if ((! isset($_POST['submit'])) or (! $_POST['services']))		{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('servicereadall');

		$__SERVICES	=	new SERVICESREAD();
		
		$SERVICES	=	$__SERVICES->readall();
		
		unset($__SERVICES);

		if ($SERVICES === FALSE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', 'loader.php?cat=section&amp;id=services');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('noservicesdefined'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
		
		load_m('namesearch');
		
		$__SEARCH = new NAMESEARCH();
		
		reset($SERVICES);
		
		$FIRST_ID =  key($SERVICES);
		
		$FIRST_NAME = $__SEARCH->byID('service', 'ebagstock.services', $FIRST_ID);
		
		unset($__SEARCH, $__SQL);

		$view	=	new View('serviceselect');

		$view 	->	assign('SELF', backward());
		$view	->	assign('SERVICESELECT', $__LANG->get('serviceselect'));		
		$view	->	assign('CODE', $__LANG->get('servicebycode'));
		$view	->	assign('NAME', $__LANG->get('servicename'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('SERVICES', $SERVICES); unset($SERVICES);
		$view	->	assign('FIRST_ID', $FIRST_ID);
		$view	->	assign('FIRST_NAME', $FIRST_NAME); unset($FIRST_ID, $FIRST_NAME);

		# set base
		$view	->	assign('BASE', 'ebagstock');

		$view	->	display();

		exit;
	}

	$SERVICEID	=	$_POST['services'];

	if (! isset($ACTION)) $ACTION = 'default';

	switch($ACTION)	{

		case('change')	:	$CATEGORY	=	'feedstockrequesttoservicechange';
					break;

		case('delete')	:	$CATEGORY	=	'feedstockrequesttoservicedelete';
					break;

		default		:	$CATEGORY	=	'feedstockrequesttoservice';
	}

	header("location: loader.php?cat=$CATEGORY&id=$SERVICEID");

?>
