<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag mobile service, feedstock, stock search
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	if (! isset($_GET['type'])) exit;
	
	$perms	=	array('service'		=> 	'services',
			      'feedstock'	=>	'feedstock',
			      'artical' 	=>	'stock');
	
	pagepermission($perms[$_GET['type']], 'r'); 
	
	# avoid empty submits
	
	if (! isset($_POST['searchcode']) or is_empty($_POST['searchcode'])) $_POST['searchcode'] = FALSE;
	if (! isset($_POST['searchname']) or is_empty($_POST['searchname'])) $_POST['searchname'] = FALSE;
	
	if ($_POST['searchcode'] or $_POST['searchname'] or isset($_GET['itemID']))	{
	
		load_c('SQL');

		$__SQL = new SQL();

		load_m('mobileitemread');
		  
		$__ITEM = new MOBILEITEMREAD();
		
		$__ITEM->set_type($_GET['type']);
	}

	if (isset($_GET['itemID']))	{
	
		$itemID		=	$_GET['itemID'];
		  
		$ITEMDATA	=	$__ITEM->readbyid($_GET['itemID']);
		
	}	elseif ($_POST['searchcode'] or $_POST['searchname'])  {

		$__ITEM->setname($_POST['searchname']);
		$__ITEM->setcode($_POST['searchcode']);
		
		$ITEMDATA	=	$__ITEM->read();
		
		$itemID		=	$__ITEM->itemID;
		
		# list with regexp matches with id
		
		if (! $ITEMDATA)	{
		  
			$ITEMLIST = $__ITEM->search();
			  
			if ($ITEMLIST)	{
			
				  unset($__SQL, $__ITEM);
				  
				  $view	= new View('mobileitemsearchresult');
				  $view	-> assign('SELF', backward().'&amp;type='.$_GET['type']);
				  $view	-> assign('SEARCHRESULTS', $__LANG->get('searchresult'));
				  $view	-> assign('ITEMLIST', $ITEMLIST); unset($ITEMLIST);
				  $view	-> display();
				  
				  exit;
			}
			
			$NOTFOUND = TRUE;
		}
	}
	
	unset($__SQL, $__ITEM);
	
	if (isset($ITEMDATA) && $ITEMDATA)	{
	
		$view	=	new View('mobileitemdetails');
		$view	->	assign('SELF', backward().'&amp;type='.$_GET['type']);
		$view	->	assign('LABEL', $__LANG->get("{$_GET['type']}details", $itemID));
		$view	->	assign('DATA', $ITEMDATA); unset($ITEMDATA);
		$view	->	display();

		exit;
	}
	
	$view	=	new View('mobileitemsearch');
	$view	->	assign('SELF', backward().'&amp;type='.$_GET['type']);
	$view	->	assign('SEARCHLABEL', $__LANG->get("{$_GET['type']}search"));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('NAME', $__LANG->get('name'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	
	if (isset($NOTFOUND)) $view -> assign('NOTFOUND', $__LANG->get('notfound'));
	
	$view	->	display();


?>
