<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag monthly statistics of working hours to employee
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('employees', 'r');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{
	
		load_c('MONTHLYHOURS');

		$__HOURS	=	new MONTHLYHOURS();

		$DATA		=	$__HOURS->read($_POST['employeeID'], $_POST['month']);

		$HTMLTABLE	=	&$__HOURS->TABLE;

		if (! $DATA)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('nodata2hoursstatistic'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('workinghourstable');
		$view	->	assign('EMPLOYEE', $__LANG->get('employeename'));
		$view	->	assign('MONTH', $__LANG->get('month'));
		$view	->	assign('E_WORK',  $__LANG->get('E_work'));
		$view	->	assign('E_NIGHT_WORK', $__LANG->get('E_night_work'));
		$view	->	assign('E_OVERTIME_WORK', $__LANG->get('E_overtime_work'));
		$view	->	assign('E_NIGHT_OVERTIME_WORK', $__LANG->get('E_night_overtime_work'));
		$view	->	assign('E_HOLIDAY', $__LANG->get('E_holiday'));
		$view	->	assign('E_SICK_LEAVE', $__LANG->get('E_sick_leave'));
		$view	->	assign('E_SICK_LEAVE_100', $__LANG->get('E_sick_leave_100'));
		$view	->	assign('E_ANNUAL_LEAVE', $__LANG->get('E_annual_leave'));
		$view	->	assign('HTMLTABLE', $HTMLTABLE);
		$view	->	assign('DATA', $DATA); unset($DATA, $__SQL);
		$view	->	display();
	
		exit;
	}

	# load employes & display the selector 

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEESDATA	=	$__EMPLOYEES->read();

	unset($__EMPLOYES, $__SQL);

	if (! $EMPLOYEESDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=employees');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	for ($i=1; $i<=12; $i++) $MONTHS[$i] = $__LANG->get("monthname$i");

	$view	=	new View('workinghoursselect');

	$view	->	assign ('SELF', backward());
	$view	->	assign('SELECT_EMPLOYEE', $__LANG->get('selectemployee'));
	$view	->	assign('EMPLOYEE', $__LANG->get('employeename'));
	$view	->	assign('MONTH', $__LANG->get('month'));
	$view	->	assign('MONTHS', $MONTHS);
	$view	->	assign('NOW', (integer)date('m'));
	$view	->	assign('EMPLOYEES', $EMPLOYEESDATA);	unset($MONTHS, $EMPLOYEESDATA);
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');

	$view	->	display();

?>
