<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new employee
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('employees');

	pagepermission('employees', 'w');

	if (isset($_POST['submit']))	{

		load_c('SQL');

		$__SQL	=  new SQL();

		load_m('employeewrite');

		$__EMPLOYEE = new EMPLOYEEWRITE();

		$RESULT = $__EMPLOYEE->write($_POST);

		unset($__EMPLOYEE, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('alertbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');
		$view	->	display();
		exit;
	}

	$view	=	new View('employee');

	$view	->	assign('LABEL', $__LANG->get('newemployee'));
	$view	->	assign('EMPLOYEENAME', $__LANG->get('employeename'));
	$view	->	assign('IDENTITY_NUMBER', $__LANG->get('identitynumber'));
	$view	->	assign('PROFESSION', $__LANG->get('profession'));
	$view	->	assign('EDUCATION_DEGREE', $__LANG->get('educationdegree'));
	$view	->	assign('WORKPLACE', $__LANG->get('workplace'));
	$view	->	assign('DATE_OF_EMPLOYMENT', $__LANG->get('date_of_employment'));
	$view	->	assign('EMPLOYEES_ADDRESS', $__LANG->get('employeesaddress'));
	$view	->	assign('CITY', $__LANG->get('city'));
	$view	->	assign('ZIP', $__LANG->get('zip'));
	$view	->	assign('STREET', $__LANG->get('street'));
	$view	->	assign('TELEPHONE', $__LANG->get('telephone'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	
	# form data

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		$_POST['date_of_employment'] = date($__CONF->get('date', 'dateformat'));
	}

	$view	->	display();

?>
