<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag operating suplie delete by number & code
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	check_year_for_write('operating_suplies');

	pagepermission('operating_suplies', 'w');

	# verifyed delete it

	if (isset($_POST['YES']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('supliedelete');

		$__SUPLIE 	=	new SUPLIEDELETE();
		$RESULT		=	$__SUPLIE->delete($_POST['id']);

		unset($__SUPLIE);

		if ($RESULT===TRUE)	{

			# deleted

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('supliedeleted', $_POST['id']));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', backward());
			$view	->	display();
			exit;
		}

		# not allowed to delete

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;

	}

	# choose service form
	
	if (! isset($_POST['submit']))	{

		$_SESSION['FROM'] = backward();

		$view	=	new View('stockselector');

		$view 	->	assign('SELF', backward());
		$view 	->	assign('SELECTLABEL', $__LANG->get('suplieselect'));
		$view 	->	assign('SELECTEDID', $__LANG->get('supliebynumber'));
		$view 	->	assign('SELECTEDCODE', $__LANG->get('supliebycode'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=operating_suplies');
		$view 	->	assign('OK', $__LANG->get('ok'));
		$view 	->	assign('RESET', $__LANG->get('reset'));
		$view 	->	assign('CANCEL', $__LANG->get('cancel'));

		$view	->	display();

		exit;
	}

	# input check

	load_c('SQL');

	$__SQL	= new SQL();

	$ID	= $_POST['id'];
	$CODE	= $_POST['code'];
	$TABLE	= 'ebagstock.operating_suplies';

	load_m('idsearch');

	$search= new IDSEARCH();

	if ((! is_empty($ID)) && (! is_empty($CODE)))	{

		$ID = $search->bycode($TABLE, $CODE);

	}	else	   {

		if (! is_empty($ID))	{

			$CODE = $search->byID($TABLE, $ID);

		}	else	 {

			if (! is_empty($CODE))	$ID = $search->bycode($TABLE, $CODE);
		}
	}
	
	unset($search, $__SQL);

	if ((! $ID) or (! $CODE)) 	{

		# bad input

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('suplienotmatch'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# verify

	$view	=	new View('verify');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodelsuplie', $ID.' ('.$__LANG->get('code').': '.$CODE.')'));
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $ID);
	$view	->	assign('BACKTO', backward());
	$view	->	display();

?>
