<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag orders partially delivery
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('deliverys');

	pagepermission('deliverys', 'w');

	if (isset($_POST['submitted']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('partiallydelivery');

		$__DELIVERY	=	new PARTIALLYDELIVERY();

		$RESULT		=	$__DELIVERY->delivery($_POST);

		$DELIVERYID	=	$__DELIVERY->getid();

		unset($__DELIVERY, $__SQL);

		if (($RESULT != 'writed') && ($RESULT != 'updated'))	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=delivery$RESULT&id=$DELIVERYID&new=part_delivery_order");

		exit;
	}

	# if selection is maded display list of deliverable items

	if (isset($_POST['selected']))	{

		unset($_POST['selected']);

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('partiallydeliverylist');

		$__DELIVERY	=	new PARTIALLYDELIVERYLIST();

		$LISTDATA	=	$__DELIVERY->create_list($_POST);

		unset($__DELIVERY, $__SQL);

		if (! is_array($LISTDATA))	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($LISTDATA));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
		
		load_f('encode_string_quotes');
		
		$LISTDATA['comment'] 	= encode_string_quotes($LISTDATA['comment']);
		$LISTDATA['annotation'] = encode_string_quotes($LISTDATA['annotation']);
		
		if (isset($LISTDATA['add2deliveryID'])) $LISTDATA['add2deliveryID'] = encode_string_quotes($LISTDATA['add2deliveryID']);

		$view	=	new View('partiallydeliverylist');

		$view	->	assign('SELF', backward());
		$view	->	assign('DELIVERYLIST', $__LANG->get('deliverylist'));
		$view	->	assign('POSSIBLE_TO_DELIVERY', $__LANG->get('possible2deliveryitems'));
		$view	->	assign('COLUMNNUMBER', $__LANG->get('personIDlong'));
		$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
		$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
		$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
		$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
		$view	->	assign('WRITE', $__LANG->get('write'));
		$view	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('BACKTO', backward());
		$view	->	assign('CANCEL', $__LANG->get('cancel'));

		# form data

		$view	->	assign('DATA', $LISTDATA); unset($LISTDATA);

		$view	->	display();

		exit;
	}

	# display first form

	$view	=	new View('orderpartiallydelivery');

	$view	->	assign('ORDERS_DELIVERY', $__LANG->get('ordersdelivery'));
	$view	->	assign('ORDER', $__LANG->get('ordernumbers'));
	$view	->	assign('ADD_COMMENT', $__LANG->get('addcomment'));
	$view	->	assign('ADD_ANNOTATION', $__LANG->get('addannotation'));
	$view	->	assign('ADD_TO_DELIVERY', $__LANG->get('addtodelivery'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=deliverys');

	$view	->	display();
?>
