<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag payments statistics print
	 */

	# note: because of performance tables print will be done with css

	ob_start('ob_gzhandler');

	define('BASEDIR', '../');

	# Reads the configuration

	require(BASEDIR.'classes/INIload.class.php');
	require(BASEDIR.'classes/Language.class.php');

	$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini');

	# Sets error handler

	require(BASEDIR.'classes/Errorhandler.class.php');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();

	# Sets session handler

	require(BASEDIR.'classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();

	register_shutdown_function('session_write_close');
	
	session_start();

	# Loads language

	$lang 	= strtolower($__CONF->get('language', 'lang'));
	
	$__LANG	= new Lang("../lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# Define essential constants

	$PRINTYPE	=	$_GET['id'];

	if (isset($_SESSION['year']))		$BASE = 'ebagdata'.$_SESSION['year'];

	if (isset($_SESSION['COMMAND']))	$COMMAND 	=	$_SESSION['COMMAND'];

	if (isset($_SESSION['LIMIT']))		$LIMIT		=	$_SESSION['LIMIT'];

	if ((! isset($BASE)) or (! isset($COMMAND)) or (! isset($LIMIT))) exit($__LANG->get('sessionexpired'));

	require(BASEDIR.'classes/SQL.class.php');

	$__SQL	= new SQL();

	if ($PRINTYPE == 'view') $COMMAND .= $LIMIT;

	$__SQL->query($COMMAND);

	if ($__SQL->num_rows())		{
	
		$VERSION_NUMBER = VERSION_NUMBER;
				
		$TEXT_DIRECTION = TEXT_DIRECTION;

		echo	<<<"EOT"
			<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
			<html>
				<head>
					<meta http-equiv="Content-Type" CONTENT="text/html; charset=utf-8">
			 		<meta name="robots" content="noindex,nofollow">
					<title>eBag</title>
					<link href="../css/$TEXT_DIRECTION/tableprint.css?ver=$VERSION_NUMBER" rel="stylesheet" type="text/css" media="print,screen">
				</head>
			<body>
			<table>
EOT;

		include (BASEDIR.'functions/mb_wrap.php');

		$COLUMNS	=	array('payment_deadline'=>'', 'sum'=>'', 'billID'=>'', 'date'=>'', 'sum'=>'', 'bank'=>'', 'printview'=>'', 'printall'=>'');

		foreach ($COLUMNS as $key=>$val) $COLUMNS[$key] = mb_wrap($__LANG->get($key), 7, '<br>');

		extract($COLUMNS); unset($COLUMNS);

		echo	<<<"EOT"
			<thead>
			<tr>
			<td class="bottom">$payment_deadline</td>
			<td class="bottom">$sum</td><td></td>
			<td class="bottom">$billID</td>
			<td class="bottom">$date</td>
			<td class="bottom">$sum</td><td></td>
			<td class="bottom">$bank</td>
			</tr>
			</thead>
			<tbody>
EOT;
		$CURR	=	$__CONF->get('payments', 'currency');

		$inc	=	0;

		ob_start();

		$__SQL->IT1_RESULT = $__SQL->RESULT;

		while ($IT_RESULT = $__SQL->IT1_RESULT->fetch_assoc())	{

			$payment_deadline = $bill_sum = $bill_link = $date_of_pay = $payment_sum = $bank = $billcurr = $paycurr = '';

			if ($IT_RESULT['type']=='claim')	{

				$billID	= $bill_ID = $IT_RESULT['ID_or_bank'];

				$__SQL->query("	SELECT `date_of_creation` 
						FROM $BASE.claims 
						WHERE `billID`='$billID' LIMIT 1	");

				if ($__SQL->num_rows())	{

					$RESULT		=	$__SQL->RESULT->fetch_row();

					$PARTS		=	explode('-', $RESULT[0]);

					$year		=	$PARTS[0];

					$billID 	.=	"/$year";

					$bill_link	=	$billID;
				}

				$payment_deadline	=	$IT_RESULT['date'];

				$bill_sum		=	$IT_RESULT['sum'];

				$billcurr		=	$CURR;


			}	else	  {

				$bank		=	$IT_RESULT['ID_or_bank'];

				$date_of_pay	=	$IT_RESULT['date'];

				$payment_sum	=	$IT_RESULT['sum'];

				$paycurr	=	$CURR;
			}

			echo 	<<<"EOT"
				<tr>
				<td>$payment_deadline</td>
				<td align="left">$bill_sum&nbsp;&nbsp;</td>
				<td align="left" width="40">$billcurr</td>
				<td width="70" align="left">$bill_link</td>
				<td>$date_of_pay</td>
				<td align="left">$payment_sum&nbsp;&nbsp;</td><td align="left" width="40">$paycurr</td>
				<td>$bank</td>
				</tr>
EOT;

			$inc++;

			if ($inc == 100)	{

				ob_end_flush();
				ob_start();
				$inc = 0;
			}
		}

		unset($__SQL->IT1_RESULT);

		echo "</tbody></table></body></html>\n";

		ob_end_flush();

		exit;
	}

	$MESSAGE = $__LANG->get('printqueryempty');

	include(BASEDIR.'views/printqueryempty.php');

?>
