<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag pdf print loader (create enviroment & load tpdf) 
	 */

	# note: print of pdfs is not called via standard loader
	#	because of gzip compression and performance reasons
	# 	pdf's are served as file download
	#	to avoid browsers inline pdf problems

	define('BASEDIR', '../');
	
	define ('eBag', TRUE);
	
	# Set time limit
	
	set_time_limit(0);

	# Load basic functions

	require_once(BASEDIR.'helpers/basichelpers.php');

	# Reads the configuration

	require(BASEDIR.'classes/INIload.class.php');
	
	require(BASEDIR.'classes/Language.class.php');
	
	require(BASEDIR.'classes/UNITloader.class.php');

	require(BASEDIR.'classes/PAYMENTloader.class.php');

	require(BASEDIR.'classes/DELIVERYloader.class.php');
	
	require(BASEDIR.'classes/PHASEloader.class.php');
	
	# Sets mbstring functions
	
	mb_internal_encoding('UTF-8');
	
	mb_regex_encoding('UTF-8');

	# Load the configuration

	$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini');
	
	# Sets error handler	

	load_c('Errorhandler');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();

	# Sets session handler

	load_c('Sessionhandler');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');	

	session_start();

	# Load language
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	= new Lang("../lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	# if the session is expired close the window

	if ((! isset($_GET['cat'])) or (! $_GET['cat']) or (! isset($_SESSION['permission'])))	{

		load_c('View');

		$view	=	new View('popupclose');
		$view	->	assign('JSDISABLED', $__LANG->get('jsdisabled'));
		$view	->	display();

		exit;
	}	

	# update session expiration

	$_SESSION['permission'] = $_SESSION['permission'];
	
	# set fonts directory
	
	$path = dirname(dirname(realpath(__FILE__)));
	
	$sep = DIRECTORY_SEPARATOR;
	
	if ($__CONF->get('font', 'directory'))	{
	
		$directory = $path.$sep.'fonts'.$sep.$__CONF->get('font', 'directory');
		  
		if (! is_dir($directory))  {
		
			if (is_dir($__CONF->get('font', 'directory')))	{
			
				$directory = realpath($__CONF->get('font', 'directory'));
			
			}	else	  {
			
				unset($directory);
			}
		}
	}	
	
	if (! isset($directory))	{
			   
		$directory = $path.$sep.'fonts'.$sep.$__CONF->get('font', 'family');
				      
		if (! is_dir($directory)) unset($directory);
	}

	if (isset($directory)) define("_SYSTEM_TTFONTS", $directory.$sep);

	# include tpdf

	include('../tfpdf/tfpdf.php');
	
	# include epdf
	
	include('../classes/ePDF.class.php');

	include(BASEDIR.'pdfwriters/'.$_GET['cat'].'.php');

?>
