<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag settings add, change or delete production phase
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	if (	(isset($_POST['addnew'])) or 
		(isset($_POST['change'])) or 
		(isset($_POST['delete']))	)	{

		$SUBMITTED	=	base64_encode(serialize($_POST));

		# note: store submitted data temporary as id

		$view	=	new View('verify');
		$view	->	assign('SELF', backward());
		$view	->	assign('QUESTION', $__LANG->get('suretochangephase'));
		$view	->	assign('YES', $__LANG->get('yes'));
		$view	->	assign('NO', $__LANG->get('no'));
		$view	->	assign('ID', $SUBMITTED);
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;
	}

	load_c('SQL');

	$__SQL	= new SQL();
	
	if (isset($_POST['YES']))	{

		load_m('productionphases');

		$__PHASES	=	new PRODUCTIONPHASES();

		$SUBMITTED	=	unserialize(base64_decode($_POST['id']));

		if (isset($SUBMITTED['addnew']))	{

			$RESULT	= $__PHASES->addnew($SUBMITTED['newtext']);

		}	elseif (isset($SUBMITTED['change']))	{

			$RESULT = $__PHASES->change($SUBMITTED['phaseID'], $SUBMITTED['newtext']);

		}	else	{

			$RESULT = $__PHASES->delete($SUBMITTED['phaseID']);
		}
	
		unset($__PHASES);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		# reload the production phases for all users
		# note: load($RELOAD = TRUE);

		$__PHASES	=	new PHASEloader($__CONF->get('cache', 'use_apc_cache'), TRUE);

		unset($__PHASES);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('settingssaved'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	$__PHASES	=	new PHASEloader($__CONF->get('cache', 'use_apc_cache'));

	$PRODUCTION_PHASES = $__PHASES->getall();
	
	# note: phase finished is unset because it is used by system

	unset($PRODUCTION_PHASES[2]);

	unset($__PHASES, $__SQL);

	$view	=	new View('production_phases');

	$view	->	assign('SELF', backward());
	$view	->	assign('PRODUCTION_PHASES', $__LANG->get('production_phases'));
	$view	->	assign('PRODUCTION_PHASE', $__LANG->get('production_phase'));
	$view	->	assign('NEW_NAME', $__LANG->get('newname'));
	$view	->	assign('SET_TO_DEFAULT', $__LANG->get('set_to_default'));
	$view	->	assign('ADDNEW', $__LANG->get('addnew'));
	$view	->	assign('CHANGE', $__LANG->get('change'));
	$view	->	assign('DELETE', $__LANG->get('delete'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');

	$view	->	assign('PHASES', $PRODUCTION_PHASES); unset($PRODUCTION_PHASES);

	$view	->	display();

?>
