<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service list open&close (finished/not finished)
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('service_lists');

	pagepermission('service_lists', 'w');

	if (isset($_POST['submit']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('servicelistfinisherwrite');

		$__REVERS	=	new SERVICELISTFINISHERWRITE();

		$RESULT		=	$__REVERS->finish($_POST);

		$MESSAGE	=	$__REVERS->MESSAGE;

		unset($__REVERS, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward()."&amp;id={$_POST['id']}");
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get($MESSAGE, $_POST['id'])); unset($_POST);
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;
	}
	
	if (isset($_POST['selected']) or isset($_GET['id']))	{

		if (isset($_GET['id'])) $_POST['id'] = $_GET['id'];

		if ((! is_empty($_POST['id'])) && ((integer)$_POST['id'] > 0))	{

			$ID	=	(integer)$_POST['id'];

			load_c('SQL');

			$__SQL	=	new SQL();

			load_m('servicelistfinisherread');

			$__REVERS	=	new SERVICELISTFINISHERREAD();

			if (! isset($_POST['date_of_creation'])) $_POST	=  $__REVERS->read($ID);

			unset($__REVERS);

			load_m('finisherread');

			$__FINISHERS	=	new FINISHERREAD();

			$FINISHERS	=	$__FINISHERS->read();

			unset($__FINISHERS, $__SQL);

			if (! $_POST)	$errtxt = 'unexistentrevers';

			if (! $FINISHERS)	$errtxt = 'nofinishers';
			
			$backward = backward();

			if (isset($errtxt))	{

				$view	=	new View('errorbox');
				$view	->	assign('SELF', $backward);
				$view	->	assign('ERROR', $__LANG->get('error'));
				$view	->	assign('ERRTXT', $__LANG->get($errtxt));
				$view	->	assign('BACK', $__LANG->get('back'));
				$view	->	display();
				exit;
			}

			$view	=	new View('servicelistfinish');

			$view	->	assign('SELF', $backward);
			$view	->	assign('PERSONID', $__LANG->get('revers'));
			$view	->	assign('CUSTOMER', $__LANG->get('customer'));
			$view 	->	assign('NOTICE', $__LANG->get('emptyreopensservicelist'));
			$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
			$view	->	assign('DATE_OF_FINISHING', $__LANG->get('date_of_finishing'));
			$view	->	assign('FINISHER', $__LANG->get('finisher'));
			$view	->	assign('NEWFINISHER', $__LANG->get('newfinisher'));
			$view	->	assign('FINISHED_NOT_FINISHED_REVERS', $__LANG->get('finishednotfinished'));
			$view	->	assign('FINISHERS', $FINISHERS); unset($FINISHERS);
			$view	->	assign('WRITE', $__LANG->get('write'));
			$view	->	assign('RESET', $__LANG->get('reset'));
			$view	->	assign('CANCEL', $__LANG->get('cancel'));
			$view	->	assign('BACKTO', $backward);
			$view	->	assign('CANCELTO', "$backward&amp;id={$ID}");

			# form data
	
			$_POST['id']	=	$ID;

			if (! isset($_POST['date_of_finishing'])) $_POST['date_of_finishing'] = date($__CONF->get('date', 'dateformat'));

			if (! isset($_POST['finisher'])) $_POST['finisher'] = $__LANG->get('notfinishedyet');

			$view	->	display();

			exit;
		}
	}

	# show selector

	$view	=	new View('listselector');

	$view 	->	assign('SELF', backward());
	$view 	->	assign('SELECTLABEL', $__LANG->get('servicelistselect'));
	$view 	->	assign('SELECTEDID', $__LANG->get('servicelistbynumber'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=service_list');
	$view 	->	assign('OK', $__LANG->get('ok'));
	$view 	->	assign('RESET', $__LANG->get('reset'));
	$view 	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	display();

?>
