<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag delete stock enter
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('stock');

	pagepermission('stock', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	# verifyed delete it

	if (isset($_POST['YES']))	{

		load_m('directstockenterdelete');

		$__ENTER	=	new DIRECTSTOCKENTERDELETE('finished_goods_stock');

		$RESULT		= 	$__ENTER->delete($_POST['id']);

		unset($__ENTER, $__SQL);

		if ($RESULT)	{

			# deleted

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('enterdeleted', $_POST['id']));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', $_SESSION['FROM']);
			$view	->	display();
			exit;
		}

		# already deleted

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# read enter data

	$ID	= $_GET['id'];

	load_m('directstockenterread');

	$__ENTER	=	new DIRECTSTOCKENTERREAD('finished_goods_stock');

	$ENTERDATA		=	$__ENTER->read($ID);
	
	unset($__ENTER);

	if (! $ENTERDATA) 	{

		# record was deleted in meantime

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('alreadydeleted'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# read artical data to show the quantity

	$UNIT	=	'';

	load_m('idsearch');

	$search	=	new IDSEARCH();

	$ARTICALID	=	$search->bycode('ebagstock.finished_goods_stock', $ENTERDATA['code']);

	unset($search);

	if ($ARTICALID)	{

		load_m('articalread');

		$__ARTICAL	=	new ARTICALREAD();
		$ARTICALDATA	=	$__ARTICAL->read($ARTICALID);

		$UNIT		=	$ARTICALDATA['unit'];

		unset($__ARTICAL, $ARTICALDATA);
	}
	
	unset($__SQL);

	# verify

	$view	=	new View('verify');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodelenter', $ID.' ('.$__LANG->get('code').': '.$ENTERDATA['code'].'=>'.$ENTERDATA['quantity'].' '.$UNIT.')'));
	unset($ENTERDATA);
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $ID);
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	display();

?>
