<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag operating suplie request change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	check_year_for_write('operating_suplies');

	pagepermission('operating_suplies', 'w');

	if (isset($_GET['id']))		{

		$REQUESTID = $_SESSION['ID'] = $_GET['id'];
		
		unset($_SESSION['_POST_ERR']);

	}	else	  {

		$REQUESTID = $_SESSION['ID'];
	}

	load_c('SQL');

	$__SQL	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('suplierequestupdate');

		$__REQUEST	=	new SUPLIEREQUESTUPDATE();
	
		$RESULT		=	$__REQUEST->update($REQUESTID, $_POST);

		unset($__REQUEST, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			# analize error type

			if (strpos($RESULT, '->') !== FALSE)	{

				list ($errtype, $point, $pointID)	= explode('->', $RESULT);

				$ERROR	=	$__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

			}	else	  {

				$ERROR	= $__LANG->get($RESULT);
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=suplierequestupdated&id=$REQUESTID");

		exit;
	}

	# read request data

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('suplierequestread');

		$__REQUEST	=	new	SUPLIEREQUESTREAD();
		$_POST		=	$__REQUEST->read($REQUESTID);

		unset($__REQUEST);

		if (! is_array($_POST))		{

			$view	=	new View('errorbox');
			$view	->	assign('SELF',  $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('unexistentsuplierequest'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}
	
	# read employees

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEESDATA	=	$__EMPLOYEES->read();

	unset($__EMPLOYES, $__SQL);

	if (! $EMPLOYEESDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=operating_suplies');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('operating_suplie_request');

	$view	->	assign('SELF', backward());
	$view	->	assign('REQUESTLABEL', $__LANG->get('suplierequestchange', $REQUESTID.'/'.$_POST['request_year']));
	$view	->	assign('REQUESTID', $REQUESTID);
	$view	->	assign('TO_EMPLOYEE', $__LANG->get('employee'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('EMPLOYEES', $EMPLOYEESDATA); unset($EMPLOYEESDATA);

	$view	->	display();
?>
