<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag user permissions 
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('users', 'w');

	if (isset($_GET['id']))		{

		$USERID = $_GET['id'];

	}	else	  {

		$USERID	= $_SESSION['ID'];
	} 
	
	load_f('mb_ereg_match_str');

	load_c('SQL');

	$__SQL	= new SQL();

	#write

	if (isset($_POST['submit']))	{

		load_m('permissionupdate');

		$__PERMISSION	=	new PERMISSIONUPDATE();

		$__PERMISSION	->	update($USERID, $_POST);
		
		unset($__PERMISSION, $__SQL);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));

		if (isset($_SESSION['FROM'])) {$FROM = $_SESSION['FROM'];} else {$FROM = 'loader.php?cat=section&amp;id=users';}

		$view	->	assign('BACKTO', $FROM.'&amp;'.$USERID);

		$view	->	display();

		exit;
	}

	# load category names from navigation language file
	
	$lang = strtolower($__CONF->get('language', 'lang'));

	$CATEGORYES	=	@file(BASEDIR."lang/$lang/navigation.$lang");
	
	unset($lang);

	if ($CATEGORYES === FALSE) trigger_error("language file $file not found", E_USER_ERROR);

	foreach ($CATEGORYES as $line)		{

		if (mb_ereg_match_str('\[(.*?)\]', $line, $sect, 'i'))	{

			list($key, $val)	=	mb_split('=>', mb_eregi_replace('^\[|\]$', '', $sect));

			$section		=	mb_eregi_replace('\s', '', $key);

			if (strpos($section, '&amp;id=')!==FALSE) list($name, $section) = explode('&amp;id=', $section);

			$CATEGORY[$section]	=	mb_eregi_replace('^\s*|\s*$', '', $val);
		}
	}

	unset($CATEGORYES);

	# read username

	load_m('namesearch');

	$search	=	new NAMESEARCH();
	
	$SURNAME	=	$search->byID('sur', 'ebag.users', $USERID);
	$LASTNAME	=	$search->byID('last', 'ebag.users', $USERID);
	$FULLNAME	=	$SURNAME.' '.$LASTNAME;

	unset($SURNAME, $LASTNAME, $search);

	# note : if the user was deleted the next step will redirect anyway 

	load_m('permissionread');

	$__PERMISSION = new PERMISSIONREAD();

	$_POST	=	$__PERMISSION->read($USERID);

	unset($__PERMISSION, $__SQL);

	if ($_POST===FALSE)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
		$view	->	assign('BACK', backward());
		$view	->	display();
		exit;
	}

	# display the form

	$view	=	new View('userpermissions');

	$view	->	assign('USERPERMISSIONS', $__LANG->get('userpermissions', $FULLNAME));
	$view	->	assign('USERNO', '('.$__LANG->get('numero', $FULLNAME).$USERID.')');
	$view	->	assign('USERID', $USERID);

	$view	->	assign('CATEGORY', $__LANG->get('category'));
	$view	->	assign('DENIED', $__LANG->get('denied'));
	$view	->	assign('READ', $__LANG->get('read'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('ADDRESSBOOK', $CATEGORY['addressbook']);
	$view	->	assign('DISCOUNTS', $CATEGORY['discounts']);
	$view	->	assign('SERVICES', $CATEGORY['services']);
	$view	->	assign('FEEDSTOCK', $CATEGORY['feedstocks']);
	$view	->	assign('OPERATINGSUPLIES', $CATEGORY['operating_suplies']);
	$view	->	assign('STOCK', $CATEGORY['stock']);
	$view	->	assign('SERVICELISTS', $CATEGORY['service_lists']);
	$view	->	assign('OFFERS', $CATEGORY['offers']);
	$view	->	assign('ORDERS', $CATEGORY['orders']);
	$view	->	assign('PRODUCTION', $CATEGORY['production']);
	$view	->	assign('DELIVERYS', $CATEGORY['deliverys']);
	$view	->	assign('BILLS', $CATEGORY['bills']);
	$view	->	assign('PAYMENTS', $CATEGORY['payments']);
	$view	->	assign('SUMMFORCUSTOMER', $CATEGORY['summary']);
	$view	->	assign('EMPLOYEES', $CATEGORY['employees']);
	$view	->	assign('SALARYS', $CATEGORY['salarys']);
	$view	->	assign('SETTINGS', $CATEGORY['settings']);
	$view	->	assign('USERS', $CATEGORY['users']);

	if (isset($_SESSION['FROM'])) {$BACKTO = $_SESSION['FROM'];} else {$BACKTO='loader.php?cat=section&amp;id=users';}

	$view	->	assign('BACKTO', $BACKTO);
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	display();
?>
