<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 *	eBag basic helper functions
	 */

	/**
	 * Checks the input string is empty string or not
	 */

	function is_empty($string)	{

		if (is_numeric($string)) return FALSE;

		if (! $string) {return TRUE;} else {return FALSE;}
	}

	/**
	 * Load model, function, class
	 */

	function load_m($model)	{

		require(BASEDIR.'models/'.$model.'.php');
	}

	function load_f($function)	{

		require(BASEDIR.'functions/'.$function.'.php');
	}

	function load_c($class)	{

		require(BASEDIR.'classes/'.$class.'.class.php');
	}
	
	/**
	 * Returns backward link to forms eg. loader?cat=category
	 */

	function backward()	{

		return 'loader.php?cat='.@$_GET['cat'];
	}

	/**
	 * Redirect if access is denied
	 */

	function pagepermission($category, $level)	  {

		# check permissions
		$values		=	array('r'=>1, 'w'=>2);
		$pos		=	strripos($_SESSION['permission'], '/'.$category.'=') + strlen($category)+2;

		if (substr($_SESSION['permission'], $pos, 1) < $values[$level]) header('location: loader.php?cat=accessdenied&c='.$category);
	}

	/**
	 * Prevents write to closed or just backuped base
	 */
	
	function check_year_for_write($c='')	{

		if (isset($_SESSION['year_is_closed'])) { header('location: loader.php?cat=closedyear&c='.$c); exit; }
		
		check_for_backup_in_progress($c);
	}

	/**
	 * Returns directory string acceptable by different platforms
	 */
	
	function safe_dir($dir)		{
	  
		 return preg_replace('/\/$/', '', preg_replace('/\\\/i', '/', $dir));
	}
	
	/**
	 * Prevents write to backuped base
	 */
	
	function check_for_backup_in_progress($c='')	{
	
		global $__CONF;
		
		clearstatcache(TRUE);
		
		if (isset($__CONF) && $__CONF->get('backup', 'directory') && is_file(safe_dir($__CONF->get('backup', 'directory')).'/backup_started.tmp')) { header('location: loader.php?cat=backupinprogress&c='.$c); exit; }
	}
	
	/**
	 * Encode quotes to entities (expects array as argument and utf-8 enviroment)
	 */
      
	function enc_quotes($array)	{
      
		foreach ($array as $key=>$val)	{
		
			if (is_array($val))	{
			
				$array[$key] = enc_quotes($val);
				
				continue;
			}
	      
			if (stripos($val, '"') !== FALSE) $array[$key] = mb_eregi_replace('"', '&quot;', $val);
		}
	      
		return $array;
	}
	
	/**
	 * Verify the post data in session var is called from current address with or without $_GET['p_err'] var
	 */
	 
	function post_data_verified()	{
	
		if (isset($_SESSION['_POST_ERR']) && 
		    isset($_SESSION['_POST_ERR']['_err_address']) && 
		    ($_SESSION['_POST_ERR']['_err_address'] == backward())) return TRUE;
		    
		return FALSE;
	}
	
	function post_get_data_verified()	{
	
	      if (post_data_verified() && isset($_GET['p_err'])) return TRUE;
	      
	      return FALSE;
	}

?>
