<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * starts eBag
	 */
	
	# Check installation
	 
	if (! is_file('conf/installed.conf'))	{
	
		header("location: controllers/install.php");
		
		exit;
	}

	# Start

	ob_start('ob_gzhandler');

	define ('BASEDIR', './');

	# Reads the configuration
	
	require(BASEDIR.'classes/INIload.class.php');

	$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini');

	# Sets the handler
	
	require(BASEDIR.'classes/Errorhandler.class.php');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();

	# Loads the language (arg TRUE reloads => develope mode)
	
	require(BASEDIR.'classes/Language.class.php');
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	= new Lang(BASEDIR."lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	$JAVASCRIPT_ERR	=	$__LANG->get('javascript_error');

	# Check for secure connection & try to change to secure connection
	 
	$HTTPS_ERR = FALSE;

	if ($__CONF->get('protocol', 'type') == 'https')	{
	
		# note:	$SERVER_SECURE_PORT is set only because of compatibility 
		# 	with configuration file older than 3.0.6 (important)
		
		if ($__CONF->get('protocol', 'secure_port')) {$SERVER_SECURE_PORT = $__CONF->get('protocol', 'secure_port');} else {$SERVER_SECURE_PORT = 443;}

		if (isset($_SERVER['SERVER_PORT']) && (($_SERVER['SERVER_PORT'] != $SERVER_SECURE_PORT)))	{

			if (! isset($_GET['redirected']))	{
			
				if (isset($_SERVER['SCRIPT_NAME'])) {$SELF = $_SERVER['SCRIPT_NAME'];} else {$SELF = $_SERVER['PHP_SELF'];}
			
				header('location: https://'.$_SERVER['HTTP_HOST'].$SELF.'?redirected=1');

				exit;
			}	

			$HTTPS_ERR=$__LANG->get('https_error');
		}
	}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head> 
		<meta HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
 		<meta name="robots" content="noindex,nofollow" />
		<title>eBag</title>
	</head>

	<body bgcolor="#FFFFFF">

		<?php if (! $HTTPS_ERR)	{ ?>

			<script type="text/javascript">location.href="controllers/login.php";</script>

			<noscript>
				<table width=100% height="200" cellpadding="0" cellspacing="0">
					<tr><td align="center" valign="center">
						<font face="verdana, arial, helvetica" size="2"> <?php echo $JAVASCRIPT_ERR; ?> </font>
					</td></tr>
				</table>
			</noscript>

		<?php } else { ?>
			<table width=100% height="200" cellpadding="0" cellspacing="0">
				<tr><td align="center" valign="center">
					<font face="verdana, arial, helvetica" size="2"> <?php echo $HTTPS_ERR; ?> </font>
				</td></tr>
			</table>
		<?php } ?>

	</body>
</html>
