<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag create bill (or add to existent bill) by IDs
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class BILLBYID	{

		var $serviceIDs		=	array();

		var $deliveryIDs	=	array();

		var $serviceIDs_str	=	'';

		var $deliveryIDs_str	=	'';
		
		var $only_2_companies 	=	FALSE;


		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];

			$this->baseyear		=	$_SESSION['year'];
			
			$__PAYMENTS		=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

			$this->EXPECTED_DAYS_TO_PAY	=	$__PAYMENTS->getvalues();

			unset($__PAYMENTS);
		}

		public function getid()		{

			if (isset($this->billID)) {return $this->billID;} else {return FALSE;}
		}
		
		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.deliverys_header WRITE, $this->BASE.deliverys_data WRITE, 
								$this->BASE.services_header WRITE, $this->BASE.services_data WRITE,
								$this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE, 
								$this->BASE.claims WRITE,
								$this->BASE.addressbook WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function collect_serviceIDs($IDs)	{

			if ((! isset($IDs)) or (! $IDs)) return;

			$array	=	explode(',', $IDs);

			if (! count($IDs)) return;

			foreach ($array as $ID)		{

				$ID	=	(integer)$ID;

				if (! $ID) continue;

				$this->SQL->query("	SELECT 	`contactname`
							FROM $this->BASE.services_header
							WHERE 	`personID`='$ID' AND `billID` IS NULL 
								AND `date_of_finishing` IS NOT NULL AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows()) $this->serviceIDs[] = $ID;
			}

			$this->serviceIDs_str	=	implode(',', $this->serviceIDs);
		}

		private function collect_deliveryIDs($IDs)	{

			if ((! isset($IDs)) or (! $IDs)) return;

			$array	=	explode(',', $IDs);

			if (! count($IDs)) return;

			foreach ($array as $ID)		{

				$ID	=	(integer)$ID;

				if (! $ID) continue;

				$this->SQL->query("	SELECT `contactname`
							FROM $this->BASE.deliverys_header
							WHERE `personID`='$ID' AND `billID` IS NULL AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows()) $this->deliveryIDs[] = $ID;
			}

			$this->deliveryIDs_str	=	implode(',', $this->deliveryIDs);
		}

		public function create($DATA)	{

			$serviceID_s	=	$DATA['reversIDs'];

			$deliveryID_s	=	$DATA['deliveryIDs'];

			if ((isset($DATA['add2billID'])) && ($DATA['add2billID']))	{

				$this->billID	=	$this->SQL->escape($DATA['add2billID']);
				
				$ACTION		=	'updated';

			}	else	{

				$ACTION		=	'writed';
			}
			
			if ((isset($DATA['only2companies'])) && ($DATA['only2companies'])) $this->only_2_companies = TRUE;
			
			$new_comment	= $DATA['comment'];
			
			$new_annotation	= $DATA['annotation'];

			unset($DATA);

			$this->SQL->transaction();
		
			$this->lock();

			$this->collect_serviceIDs($serviceID_s);

			$this->collect_deliveryIDs($deliveryID_s);

			unset($serviceID_s, $deliveryID_s);

			if ((! count($this->serviceIDs)) && (! count($this->deliveryIDs)))	{

				$this->SQL->rollback();

				$this->unlock();

				return 'notexistsbilledornotfinished';
			}

			# check the defined IDs is for one customer

			$COMMAND1	=	$COMMAND2	=	FALSE;

			if ($this->serviceIDs_str) $COMMAND1 = "	SELECT `contactID` 
									FROM $this->BASE.services_header
									WHERE `personID` IN ($this->serviceIDs_str) AND `deleted` IS NOT NULL GROUP BY `contactID`	";

			if ($this->deliveryIDs_str) $COMMAND2 =	"	SELECT `contactID` 
									FROM $this->BASE.deliverys_header 
									WHERE `personID` IN ($this->deliveryIDs_str) AND `deleted` IS NOT NULL GROUP BY `contactID`	";

			if ($COMMAND1 && $COMMAND2)	{

				$COMMAND = '('.$COMMAND1.') UNION ('.$COMMAND2.')';

			}	else	  {

				$COMMAND = $COMMAND1.$COMMAND2;
			}

			$this->SQL->query($COMMAND); 

			if ($this->SQL->num_rows() != 1)	{

				$this->SQL->rollback();

				$this->unlock();

				return 'differentcustomer2bill';
			}

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$contactID	=	$RESULT[0];

			# check the defined bill is to this customer

			if (isset($this->billID))		{

				$this->SQL->query("	SELECT `contactID`, `comment`, `annotation` 
							FROM $this->BASE.bills_header
							WHERE `personID`='$this->billID' AND `deleted` IS NOT NULL	");

				if ($this->SQL->num_rows())	{

					$RESULT		=	$this->SQL->RESULT->fetch_assoc();

					if ($contactID != $RESULT['contactID']) $errtxt = 'differentbillID2bill';
					
					# set the new comment
					
					$comment = '';
					
					if ($RESULT['comment'])	$comment = $this->SQL->r_escape($RESULT['comment']); 
					
					if (! is_empty($new_comment)) $comment .= $this->SQL->escape($new_comment);
					
					if (! $comment) {$comment = 'NULL';} else {$comment = "'$comment'";}
					
					# set the new annotation
					
					$annotation = '';
					
					if ($RESULT['annotation']) $annotation = $this->SQL->r_escape($RESULT['annotation']); 
					
					if (! is_empty($new_annotation)) $annotation .= $this->SQL->escape($new_annotation);
					
					if (! $annotation) {$annotation = 'NULL';} else {$annotation = "'$annotation'";}

				}	else	 {

					$errtxt = 'unexistentbill';
				}

				if (isset($errtxt))	{

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}
			}

			# check payment form is the same

			$COMMAND1	=	$COMMAND2	=	FALSE;

			if ($this->serviceIDs_str) $COMMAND1  = "	SELECT `payment_form` 
									FROM $this->BASE.services_header
									WHERE `personID` IN ($this->serviceIDs_str) AND `deleted` IS NOT NULL GROUP BY `payment_form`	";

			if ($this->deliveryIDs_str) $COMMAND2 =	"	SELECT `payment_form` 
									FROM $this->BASE.deliverys_header 
									WHERE `personID` IN ($this->deliveryIDs_str) AND `deleted` IS NOT NULL GROUP BY `payment_form`	";

			if ($COMMAND1 && $COMMAND2)	{

				$COMMAND = '('.$COMMAND1.') UNION ('.$COMMAND2.')';

			}	else	  {

				$COMMAND = $COMMAND1.$COMMAND2;
			}

			unset($COMMAND1, $COMMAND2);

			$this->SQL->query($COMMAND);

			if ($this->SQL->num_rows() != 1)	{

				$this->SQL->rollback();

				$this->unlock();

				return 'differentpayment2bill';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			if (! $this->EXPECTED_DAYS_TO_PAY)	{

				$errtxt = 'fatalerror';

			}	else	{

				if (! isset($this->EXPECTED_DAYS_TO_PAY[$RESULT[0]]))	$errtxt = 'fatalerror';
			}
	
			if (isset($errtxt))	{

				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}

		 	$EXPECTED_PAYMENT = $this->EXPECTED_DAYS_TO_PAY[$RESULT[0]];

			if (! $EXPECTED_PAYMENT)	{

				# note: if expected days to pay is zero, then customers pays in cash
				#	and will get cash bill

				$this->SQL->rollback();

				$this->unlock();

				return 'customerpayswithcash';
			}

			$now = date("Y-m-d");

			$payment_deadline	=	date("Y-m-d", strtotime($EXPECTED_PAYMENT.' days'));
			
			# check contacttype
			
			if ($this->only_2_companies)	{
			
				$this->SQL->query("	SELECT `contactname`
							FROM $this->BASE.addressbook
							WHERE `personID`='$contactID' AND `contacttype`='1' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{
				
					$this->SQL->rollback();

					$this->unlock();

					return 'customerpayswithcash';
				}
			}

			if (! isset($this->billID))	{

				# create new bill

				if ($this->serviceIDs_str)	{

					$TABLE	=	'services_header'; 
					$readID	= 	$this->serviceIDs[0];

				}	else	{

					$TABLE 	=	'deliverys_header';
					$readID	=	$this->deliveryIDs[0];
				}

				# note: companyID, currency will read from sended delivery or revers

				$this->SQL->query("	SELECT	`companyID`, `contactID`, `contactname`, `account1`, `bank1`, 
								`account2`, `bank2`, `contacttype`, `currency`, `payment_form`
							FROM $this->BASE.$TABLE 
							WHERE `personID`='$readID' AND `deleted` IS NOT NULL LIMIT 1	");

				# note: must to be row, checked after lock

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				foreach($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

				extract($RESULT);

				# reread the address data from addressbook because of delivery address
			
				$this->SQL->query("	SELECT `country`, `city`, `zip`, `street`
							FROM $this->BASE.addressbook
							WHERE `personID`=$contactID AND `deleted` IS NOT NULL LIMIT 1	");
							
				# cannot be but for any case
							
				if (! $this->SQL->num_rows())	{
				
					$this->SQL->rollback();

					$this->unlock();

					return 'unexistentcontact';
				}
							
				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				foreach($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

				extract($RESULT);
				
				$comment	= $this->SQL->n_escape($new_comment);
				
				$annotation	= $this->SQL->n_escape($new_annotation);

				$this->SQL->query("	INSERT INTO $this->BASE.bills_header 
							VALUES 
							(NULL, $companyID, $contactID, $contactname, $country, $city, $zip, 
							$street, $account1, $bank1, $account2, $bank2, $contacttype, $currency, 
							$payment_form, NULL, NULL, '$now', '$payment_deadline', $comment, $annotation, NULL, '0')	");

				$this->billID	=	$this->SQL->lastid();

			}	else	  {

				# update existing bill

				$this->SQL->query("	UPDATE $this->BASE.bills_header
							SET 	`date_of_creation`='$now', `payment_deadline`='$payment_deadline', 
								`comment`=$comment, `annotation`=$annotation 
							WHERE `personID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			# write delivery list data

			if ($this->deliveryIDs_str)	{

				$this->SQL->query("	SELECT `personID`, `code`, `name`, `quantity`, `unit`, `price`, `tax`
							FROM $this->BASE.deliverys_data
							WHERE `deliveryID` IN ($this->deliveryIDs_str)	AND `deleted` IS NOT NULL  ORDER BY `deliveryID`, `personID` 	");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT	=  $this->SQL->RESULT;

					while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

						foreach ($RESULT as $key=>$val) $RESULT[$key] = $this->SQL->nr_escape($val);

						extract($RESULT); unset($RESULT);

						# note: datatype d=>delivery, s=>service

						$this->SQL->query("	INSERT INTO $this->BASE.bills_data 
									VALUES 
									(NULL, '$this->billID', $code, $name, $quantity, $unit, $price, $tax, $personID, 'd', '0')	");
					}

					unset($this->SQL->IT1_RESULT);
				}

				# update connected with orders in header

				foreach ($this->deliveryIDs as $deliveryID)	{

					$this->SQL->query("	SELECT `connected_with_deliverys` 
								FROM $this->BASE.bills_header
				 	 			WHERE 	(`connected_with_deliverys` NOT REGEXP '-$deliveryID-' OR `connected_with_deliverys` IS NULL) 
									AND `personID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT	=	$this->SQL->RESULT->fetch_row();

						if ($connected_with_deliverys = $RESULT[0])	{

							$connected_with_deliverys	.=	"$deliveryID-";

						}	else	  {

							$connected_with_deliverys	=	"-$deliveryID-";
						}

						$this->SQL->query("	UPDATE $this->BASE.bills_header
									SET `connected_with_deliverys`='$connected_with_deliverys'
									WHERE `personID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");
					}
				}

				# update deliverys header set to billed

				$this->SQL->query("	UPDATE $this->BASE.deliverys_header
							SET `billed`='1', `billID`='$this->billID' 
							WHERE `personID` IN ($this->deliveryIDs_str)	");
			}

			# write reverses

			if ($this->serviceIDs_str)	{

				foreach ($this->serviceIDs as $reversID)	{

					# calculate real price coefs for each revers (deliverys contains the real prices)

					$this->SQL->query("	SELECT 	`exchange_rate`, `service_discount`,  `session_discount`, 
									`use_service_discount`, `use_session_discount`
								FROM $this->BASE.services_header
								WHERE `personID`='$reversID' AND `deleted` IS NOT NULL LIMIT 1	");

					$RESULT	=	$this->SQL->RESULT->fetch_assoc();

					extract($RESULT); unset($RESULT);

					$SESSION_COEF = $SERVICE_COEF = 1;

					if (($use_session_discount) && ($session_discount>0))	$SESSION_COEF = (100-$session_discount) / 100;

					if (($use_service_discount) && ($service_discount>0))	$SERVICE_COEF = (100-$service_discount) / 100;

					$GLOBAL_COEF	=	$SESSION_COEF * $SERVICE_COEF * $exchange_rate;

					# write articles

					$this->SQL->query("	SELECT `personID`, `code`, `servicename`, `quantity`, `unit`, `price`, `tax`
								FROM $this->BASE.services_data 
								WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

					if ($this->SQL->num_rows())	{

						$this->SQL->IT1_RESULT = $this->SQL->RESULT;

						while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())		{

							foreach ($RESULT as $key=>$val)	{

								if ($key == 'price')	{

									$RESULT[$key] = $this->SQL->escape($val * $GLOBAL_COEF);

									continue;
								}									

								$RESULT[$key] = $this->SQL->nr_escape($val);
							}

							extract($RESULT); unset($RESULT);

							# note: datatype d=>delivery, s=>service

							$this->SQL->query("	INSERT INTO $this->BASE.bills_data
										VALUES 
										(NULL, '$this->billID', $code, $servicename, $quantity, $unit, $price, $tax, $personID, 's', '0')	");
						}
			
						unset($this->SQL->IT1_RESULT);
					}

					# update connected with reverses

					$this->SQL->query("	SELECT `connected_with_reverses` 
								FROM $this->BASE.bills_header
					  			WHERE 	(`connected_with_reverses` NOT REGEXP '-$reversID-' OR `connected_with_reverses` IS NULL) 
									AND `personID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT	=	$this->SQL->RESULT->fetch_row();

						if ($connected_with_reverses = $RESULT[0])	{

							$connected_with_reverses	.=	"$reversID-";

						}	else	  {

							$connected_with_reverses	=	"-$reversID-";
						}


						$this->SQL->query("	UPDATE $this->BASE.bills_header
									SET `connected_with_reverses`='$connected_with_reverses'
						  			WHERE `personID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");
					}
				}

				# update services header set to billed

				$this->SQL->query("	UPDATE $this->BASE.services_header
							SET `billed`='1', `billID`='$this->billID' 
							WHERE `personID` IN ($this->serviceIDs_str)	");
			}

			# check for empty bill

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.bills_data 
						WHERE `billID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'cannotcreateemptybill_1';
			}

			# update claims

			$this->SQL->query("	SELECT SUM(price * quantity * ((100 + tax)/100))
						FROM $this->BASE.bills_data WHERE `billID`='$this->billID' AND `deleted` IS NOT NULL	");

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$PRICE_SUM_WITH_TAX	=	$RESULT[0];

			$this->SQL->query("	SELECT `contactID`, `contactname`, `city`, `date_of_creation`, `payment_deadline`
						FROM $this->BASE.bills_header
						WHERE `personID`='$this->billID' AND `deleted` IS NOT NULL LIMIT 1	");

			$RESULT		=	$this->SQL->RESULT->fetch_assoc();

			extract($RESULT);

			# delete old record

			$this->SQL->query("	DELETE FROM $this->BASE.claims 
						WHERE `billID`='$this->billID' AND `baseyear`='$this->baseyear' LIMIT 1	");

			# insert new one

			$this->SQL->query("	INSERT INTO $this->BASE.claims
						VALUES 
						(NULL, '$this->billID', '$date_of_creation', '$payment_deadline', '$contactID', 
						'$contactname', '$city', '$PRICE_SUM_WITH_TAX', '$this->baseyear', '0')	");

			$this->SQL->commit();

			$this->unlock();

			return $ACTION;
		}
	}
?>
