<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag direct stock enter delete (stock, feedstock, operating_suplies)
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class DIRECTSTOCKENTERDELETE	{

		function __construct($STOCKTABLE)	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->STOCKTABLE	=	$STOCKTABLE;

			$this->ENTERTABLE	=	$this->STOCKTABLE.'_enter';

		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->STOCKBASE.$this->STOCKTABLE WRITE, 
							$this->BASE.$this->ENTERTABLE WRITE,
							$this->BASE.orders_to_stock_header WRITE,
							$this->BASE.orders_to_stock_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();

			$this->lock();

			# check the record exists (& prevents refreshes)

			$this->SQL->query("	SELECT `code`, `quantity`, `order_to_stockID` 
						FROM $this->BASE.$this->ENTERTABLE 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'alreadydeleted';				
			}

			$RESULT			=	$this->SQL->RESULT->fetch_assoc();

			$code			=	$this->SQL->r_escape($RESULT['code']);

			$quantity		=	$RESULT['quantity'];

			$ordertostockID		=	$RESULT['order_to_stockID'];

			$username		=	$this->SQL->escape($_SESSION['username']);

			# delete record

			$this->SQL->query("	UPDATE $this->BASE.$this->ENTERTABLE 
						SET `deleted`=NULL, `username`='$username' 
						WHERE `personID`='$ID' LIMIT 1	");

			# update stock

			$this->SQL->query("	UPDATE $this->STOCKBASE.$this->STOCKTABLE 
						SET quantity=quantity-$quantity 
						WHERE `code`='$code' LIMIT 1	");

			# if the enter is connected with order to stock set the item to undelivered

			if ($ordertostockID)	{

				$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_data
							SET `date_of_delivery`=NULL, `delivery_list_number`=NULL, `bill_number`=NULL
							WHERE `code`='$code' AND `order2stockID`='$ordertostockID' AND `deleted` IS NOT NULL LIMIT 1	");

				# check the state of this order to stock
				# note: states 0=>No 2=>In part
				
				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.orders_to_stock_data 
							WHERE `order2stockID`='$ordertostockID' AND `date_of_delivery` IS NOT NULL AND `deleted` IS NOT NULL ");

				if ($this->SQL->num_rows()) {$STATE = '2';} else {$STATE = '0';}

				$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_header
							SET `delivered`='$STATE' 
							WHERE `personID`='$ordertostockID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
