<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag feedstock request for service list delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class FEEDSTOCKREQUEST2LISTDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;
			
			$this->BASE		=	$_SESSION['BASE'];
			
			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()		{

			$this->SQL->query("LOCK TABLES	$this->BASE.feedstock_requests WRITE, 
							$this->BASE.services_header WRITE, 
							$this->STOCKBASE.feedstock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID, $REASON)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();

			$this->lock();

			# check closed reverses connected with indent

			$this->SQL->query("	SELECT `personID` FROM $this->BASE.services_header
						WHERE `personID` IN	(	SELECT `reversID` 
										FROM $this->BASE.feedstock_requests 
										WHERE `requestID`='$ID' AND `deleted` IS NOT NULL GROUP BY `reversID`
									)
						AND `deleted` IS NOT NULL AND `date_of_finishing` IS NOT NULL	");

			if ($this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'closereversconnectedwith';
			}

			# update the feedstock

			$this->SQL->query("	SELECT `code`, `quantity` 
						FROM $this->BASE.feedstock_requests 
						WHERE `requestID`='$ID' AND `deleted` IS NOT NULL	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'request2listnotexists';
			}

			$this->SQL->IT1_RESULT	=	$this->SQL->RESULT;

			while	($RESULT	=	$this->SQL->IT1_RESULT->fetch_assoc())	{

				$feedstockCODE		=	$this->SQL->r_escape($RESULT['code']);
				$feedstockQUANTITY	=	$RESULT['quantity'];

				$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock 
							SET	quantity=quantity+$feedstockQUANTITY,
		 						quantity_in_production=quantity_in_production-$feedstockQUANTITY
							WHERE `code`='$feedstockCODE' AND `deleted` IS NOT NULL LIMIT 1"	);
			}

			unset($this->SQL->IT1_RESULT);

			# write delete reason in first row

			$delete_reason	=	$this->SQL->n_escape($REASON);

			$this->SQL->query("	UPDATE $this->BASE.feedstock_requests 
						SET `delete_reason`=$delete_reason
						WHERE `requestID`='$ID' AND `deleted` IS NOT NULL LIMIT 1"	);

			# delete all

			$this->SQL->query("	UPDATE $this->BASE.feedstock_requests 
						SET `deleted`=NULL 
						WHERE `requestID`='$ID' AND `deleted` IS NOT NULL	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
