<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag feedstockrequest for service list write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class FEEDSTOCKREQUEST2LISTWRITE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;
			
			$this->BASE		=	$_SESSION['BASE'];
			
			$this->STOCKBASE	=	'ebagstock';
		}

		public function getid()	{

			if (isset($this->requestID)) {return $this->requestID;}  else {return FALSE;}
		}
		

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.feedstock_requests WRITE, 
							$this->BASE.services_data WRITE, 
							$this->STOCKBASE.services WRITE, 
							$this->STOCKBASE.feedstock WRITE, 
							$this->STOCKBASE.feedstock_requests_list WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function write($ID_s)	{

			if (! count($ID_s)) return 'noinput';

			$this->SQL->transaction();

			$this->lock();

			# select the last requestID

			$this->SQL->query("	SELECT MAX(`requestID`) AS `requestID` 
						FROM $this->BASE.feedstock_requests	");

			$RESULT	= $this->SQL->RESULT->fetch_row();

			$this->requestID	=	(integer)($RESULT[0] + 1);

			foreach ($ID_s as $ID)	{

				# select ids & code & quantity in service_data 

				$this->SQL->query("	SELECT `personID`, `code`, `quantity` 
							FROM $this->BASE.services_data 
							WHERE `reversID`='$ID' AND `deleted` IS NOT NULL	");

				if (! $this->SQL->num_rows())	{

					$errtxt = 'unexistentreverses->personID->'.$ID;
					break;
				}

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($G_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$servicedataID		=	$G_RESULT['personID'];
					$serviceCODE		=	$this->SQL->r_escape($G_RESULT['code']);
					$serviceQUANTITY	=	$G_RESULT['quantity'];

					# select serviceID in stock for defined code

					$this->SQL->query("	SELECT `personID` 
								FROM $this->STOCKBASE.services 
								WHERE `code`='$serviceCODE' AND `deleted` IS NOT NULL LIMIT 1	");

					if (! $this->SQL->num_rows())	{

						$errtxt = 'servicenotexists->code->'.$serviceCODE;
						break 2;
					}

					$RESULT		=	$this->SQL->RESULT->fetch_row();
					$serviceID	=	$RESULT[0];

					# select defined request list for this service

					$this->SQL->query("	SELECT `code`, `feedstockname`, `unit`, `quantity` 
								FROM $this->STOCKBASE.feedstock_requests_list 
								WHERE `serviceID`='$serviceID' AND `deleted` IS NOT NULL ORDER BY `personID` ");
					
					if ($this->SQL->num_rows())	{

						$this->SQL->IT2_RESULT = $this->SQL->RESULT;

						while ($RESULT = $this->SQL->IT2_RESULT->fetch_assoc())	{

							$feedstockCODE		=	$this->SQL->r_escape($RESULT['code']);
							$feedstockNAME		=	$this->SQL->r_escape($RESULT['feedstockname']);
							$feedstockUNIT		=	$this->SQL->r_escape($RESULT['unit']);
							$feedstockQUANTITY	=	$RESULT['quantity'];

							if ((is_empty($feedstockCODE)) or (is_empty($feedstockNAME)) or (is_empty($feedstockUNIT)) or (is_empty($feedstockQUANTITY)))	{

								$errtxt	=	'invalidrequestlist->code->'.$serviceCODE;
								break 3;
							}

							# select id in stock for defined feedstock code

							$this->SQL->query("	SELECT `personID` 
										FROM $this->STOCKBASE.feedstock 
										WHERE `code`='$feedstockCODE' AND `deleted` IS NOT NULL LIMIT 1	");

							if (! $this->SQL->num_rows())	{

								$errtxt	=	'feedstocknotexists->code->'.$feedstockCODE;
								break 3;
							}

							# insert request

							$date_of_creation	=	date("Y-m-d");

							$this->SQL->query("INSERT INTO $this->BASE.feedstock_requests VALUES (	NULL, '$this->requestID', '$ID', '$servicedataID', 
																'$date_of_creation', '$feedstockCODE', 
																'$feedstockNAME', '$feedstockUNIT', 
																'$feedstockQUANTITY', NULL, '0')");

							# update the stock (feedstock)

							$NEWQUANTITY=(double)$serviceQUANTITY*(double)$feedstockQUANTITY;

							$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock 
										SET 	quantity=quantity-$NEWQUANTITY, 
											quantity_in_production=quantity_in_production+$NEWQUANTITY 
										WHERE `code`='$feedstockCODE' AND `deleted` IS NOT NULL LIMIT 1	");

							# backwards check the quantity is enough

							$this->SQL->query("	SELECT `personID` 
										FROM $this->STOCKBASE.feedstock 
										WHERE `code`='$feedstockCODE' AND `quantity`<0 AND `deleted` IS NOT NULL LIMIT 1	");

							# the row cannot be now deleted

							if ($this->SQL->num_rows())	{

								$errtxt = 'notenoughfeedstock->code->'.$feedstockCODE;
								break 3;
							}
						}
					}
				}
			}

			unset($this->SQL->IT1_RESULT, $this->SQL->IT2_RESULT);

			# at the end check the request is not empty

			if (! isset($errtxt))	{

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.feedstock_requests 
							WHERE `requestID`='$this->requestID' AND `deleted` IS NOT NULL	");
		
				if (! $this->SQL->num_rows())	$errtxt = 'emptyrequest';
			}

			if (isset($errtxt))	{

				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
