<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag feedstock write read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('addtax');

	load_f('is_real_positive');
	
	load_f('is_longer');

	class FEEDSTOCKUPDATE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function prepare($DATA)	 {

			# Check user input

			if ((is_empty($DATA['feedstockname'])) or 
			    (is_empty($DATA['code'])) or
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['unit'])) or
			    (is_empty($DATA['dimensions']))) return FALSE;

			if (((! is_empty($DATA['calculation_price'])) && ((! is_numeric($DATA['calculation_price'])) or ($DATA['calculation_price'] < 0))) or 
			    ((! is_empty($DATA['purchase_price'])) && ((! is_numeric($DATA['purchase_price'])) or ($DATA['purchase_price'] < 0)))) return FALSE;
			    
			# Change empty prices to zero
			
			if (is_empty($DATA['purchase_price'])) 		$DATA['purchase_price'] = 0;
			if (is_empty($DATA['calculation_price'])) 	$DATA['calculation_price'] = 0;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;			
		}

		private function lock()	{

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR) $TO_LOCK .= ", ebagdata$YEAR.feedstock_enter WRITE, ebagdata$YEAR.feedstock_requests WRITE";

			$this->SQL->query("LOCK TABLES ebag.years WRITE, $this->BASE.addressbook WRITE, ebagstock.feedstock WRITE".$TO_LOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL	');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row())	$this->OPENED[] = $RESULT[0];
		}

		public function update($ID, $DATA)	{

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			$this->lock();

			$ID = $this->SQL->escape($ID);

			extract($DATA); unset($DATA);

			# check supplier exists

			$this->SQL->query("	SELECT `city` 
						FROM $this->BASE.addressbook 
						WHERE `personID`=$supplierID AND `contactname`=$supplier AND `deleted` is NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return 'suppliernotmatch';
			}

			# check the new feedstock code exists

			$this->SQL->query("	SELECT `feedstockname` 
						FROM $this->STOCKBASE.feedstock 
						WHERE `personID`!='$ID' AND `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();
				return 'feedstockexists';
			}

			# check the feedstock is not deleted in meantime

			$this->SQL->query("	SELECT `code` 
						FROM $this->STOCKBASE.feedstock 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return 'deletedinmeantime';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			# if the artical name and code is changed, see is possible to change or not

			if ($code != "'".$RESULT['code']."'")	{

				$OLDCODE	=	$this->SQL->r_escape($RESULT['code']);

				# check the stock
				$this->SQL->query("	SELECT `quantity`, `quantity_ordered_to_stock`, `quantity_on_opened_order_to_stock`, `quantity_in_production`
							FROM $this->STOCKBASE.feedstock 
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if (($RESULT[0] > 0) or ($RESULT[1] > 0) or ($RESULT[2] > 0) or ($RESULT[3] > 0)) $errtxt = 'ordered_or_entered_item'; 

				if (! isset($errtxt))	{

					foreach ($this->OPENED as $YEAR)	{

						$this->SQL->query("	SELECT `personID` 
									FROM ebagdata$YEAR.feedstock_enter 
									WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$errtxt	= "ordered_or_entered->year->$YEAR";

							break;
						}

						$this->SQL->query("	SELECT `personID` 
									FROM ebagdata$YEAR.feedstock_requests 
									WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$errtxt	= "feedstock_requested->year->$YEAR";

							break;
						}
					}
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}

			$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock 
						SET	`code`=$code, `feedstockname`=$feedstockname, `dimensions`=$dimensions, `unit`=$unit,
							`purchase_price`=$purchase_price, `calculation_price`=$calculation_price,
							`origin`=$origin, `supplier`=$supplier, `supplierID`=$supplierID, `comment`=$comment
						WHERE `personID`='$ID' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}
	}

?>
