<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag contact read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class MOBILECONTACTREAD	{
	
		function __construct()	{

			global $__SQL, $__LANG;
			
			$this->contactID	=	FALSE;

			$this->SQL		=	&$__SQL;
			
			$this->BASE		=	$_SESSION['BASE'];
			
			$this->LANG		=	&$__LANG;
		}

		public function readbyname($name)	{

			$name	=	$this->SQL->escape($name);

			$this->SQL->query("	SELECT * 
						FROM $this->BASE.addressbook 
						WHERE `contactname`='$name' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			return $this->fetch_data();
		}
		
		public function readbyid($id)	{

			$id	=	$this->SQL->escape($id);

			$this->SQL->query("	SELECT * 
						FROM $this->BASE.addressbook 
						WHERE `personID`='$id' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			return $this->fetch_data();
		}
		
		private function fetch_data()	{
		
			$RESULT = $this->SQL->RESULT->fetch_assoc();
			
			$data 	= array();
		
			$columns = array('contactname', 'contactperson', 'country', 'city', 'zip', 'street', 'telephone1', 'telephone2', 'fax', 'mobilephone', 'mail', 
					'website', 'contacttype', 'delivery_country', 'delivery_city', 'delivery_street', 'delivery_zip', 'delivery_day_of_week',
					'account1', 'bank1', 'account2', 'bank2');
				 
			$RESULT['contacttype'] = $this->LANG->get('type'.$RESULT['contacttype']);
		
			$RESULT['delivery_day_of_week'] = $this->LANG->get('day'.$RESULT['delivery_day_of_week']);
				 
			foreach($columns as $column)	{
			
				if (! is_empty($RESULT[$column])) $data[$this->LANG->get(str_replace('_', '', $column))] = $RESULT[$column];
			}
		
			if (! is_empty($RESULT['tax_id_number'])) $data[$this->LANG->get('taxidno')] = $RESULT['tax_id_number'];
			
			if (! count($data)) return FALSE;
			
			$this->contactID = $RESULT['personID'];
			
			return $data;
		}
		
		public function searchbyname($name)	{
		
			# Case insensitive search 
			
			$name 	=	$this->SQL->s_escape(mb_strtolower($name), 'REGEXP');
			
			$this->SQL->query("	SELECT `personID`, `contactname` 
						FROM $this->BASE.addressbook 
						WHERE LOWER(`contactname`) REGEXP '$name' AND `deleted` IS NOT NULL ");
			
			$data = FALSE;
			
			if ($this->SQL->num_rows())	{
			
				 $data = array();
				  
				 while ($RESULT = $this->SQL->RESULT->fetch_assoc()) $data[$RESULT['personID']]=$RESULT['contactname'];
			}
			
			return $data;
		}

	}

?>
