<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag read order to stock data for partially delivered orders
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDER2STOCKDATA	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL		=	&$__SQL;
			
			$this->LANG		=	&$__LANG;

			$this->BASE		=	$_SESSION['BASE'];
			
			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES	$this->BASE.orders_to_stock_header WRITE, 
								$this->BASE.orders_to_stock_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}
		
		public function get()	{
		
			return $this->data;
		}
		
		public function read($order2stockID)	{

			if (! $order2stockID) return 'unexistentorder2stock';
			
			$order2stockID = $this->SQL->escape($order2stockID);
			
			$this->data = array();

			$this->lock();

			# verify the order exists, is ordered (closed)

			$this->SQL->query("	SELECT DATE_FORMAT(`date_of_order`, '$this->FORMAT') AS `date_of_order`,
						      `contactname`
						FROM $this->BASE.orders_to_stock_header
				  		WHERE  `personID`='$order2stockID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'unexistentorder2stock';
			}

			$RESULT	= $this->SQL->RESULT->fetch_assoc();

			if (! ($this->data['date_of_order'] = $RESULT['date_of_order'])) $errtxt = 'unclosedorder2stock';

			$this->data['supplier'] = $RESULT['contactname'];
			
			# verify there is not delivered items on order
			
			$this->SQL->query("	SELECT `personID`
						FROM $this->BASE.orders_to_stock_data
			  			WHERE  `order2stockID`='$order2stockID' AND `date_of_delivery` IS NULL AND `deleted` IS NOT NULL ");
			  			
			if (! $this->SQL->num_rows()) $errtxt = 'deliveredonceorder2stock';

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}
			
			$TYPES	=	array(	'a'	=>	'artical',
						'f'	=>	'feedstock'	);

			$this->SQL->query("	SELECT `personID`, `code`, `name`, `quantity`, `unit`, `type`, `date_of_delivery`
						FROM $this->BASE.orders_to_stock_data
			  			WHERE  `order2stockID`='$order2stockID' AND `deleted` IS NOT NULL ORDER BY `personID` ");
		
			if ($this->SQL->num_rows())	{
			
				$found = TRUE;

				while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{
				
					$this->data['personID'][]	=	$RESULT['personID'];
				
					$this->data['type'][]		=	$this->LANG->get($TYPES[$RESULT['type']]);

					$this->data['code'][]		=	$RESULT['code'];
					
					$this->data['name'][]		=	$RESULT['name'];

					$this->data['quantity'][]	=	$RESULT['quantity'];
					
					$this->data['unit'][]		=	$RESULT['unit'];
					
					if ($RESULT['date_of_delivery']) {$this->data['delivered'][] = TRUE;} else {$this->data['delivered'][] = FALSE;}
				}
			}

			$this->unlock();

			if (! isset($found)) return 'unknownerror';
			
			return TRUE;
		}
	}
?>
