<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag order details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDERDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;
			
			$this->LANG	=	&$__LANG;
			
			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
			
			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.orders_header WRITE, 
							$this->BASE.orders_data WRITE,
							$this->BASE.production_orders_header WRITE");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{
		
			$DATA	=	FALSE;

			$ID	=	$this->SQL->escape($ID);

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;
			
			# read payments and deliverys

			$__PAYMENTS = new PAYMENTloader($this->APC);

			$PAYMENT_FORMS = $__PAYMENTS->getnames();
			
			unset($__PAYMENTS);

			$__DELIVERYS	= new DELIVERYloader($this->APC);

			$DELIVERY_TYPES	= $__DELIVERYS->gettypes();
			
			unset($__DELIVERYS);
			
			# read

			$this->lock();

			$this->SQL->query("	SELECT 	`contactname`, `country`, `city`, `zip`, `street`, `article_discount`, 
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`date_of_deadline`, '$this->FORMAT') AS `date_of_deadline`,
							`delivery_day_of_week`, `comment`, `annotation`, `currency`, `exchange_rate`, `session_discount`, 
							`use_session_discount`, `use_article_discount`, `connected_with_offer`, `delivery_form`, `payment_form` 
						FROM $this->BASE.orders_header
						WHERE personID='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				$DATA['order_year']	=	str_replace('ebagdata', '' , $this->BASE);

				if (isset($PAYMENT_FORMS[$DATA['payment_form']])) $DATA['payment_form']	= $PAYMENT_FORMS[$DATA['payment_form']];

				unset($PAYMENT_FORMS);

				if (isset($DELIVERY_TYPES[$DATA['delivery_form']])) $DATA['delivery_form'] = $DELIVERY_TYPES[$DATA['delivery_form']];

				unset($DELIVERY_TYPES);

				$DATA['delivery_day_of_week'] = $this->LANG->get('day'.$DATA['delivery_day_of_week']);

				# read data
		
				$this->SQL->query("	SELECT 	`code`, `articalname`, `quantity`, `unit`, `price`, `tax`, `deliverylistID`, `productionorderID`, 
								DATE_FORMAT(`date_of_delivery`, '$this->FORMAT') AS `date_of_delivery`
							FROM $this->BASE.orders_data 
							WHERE `orderID`='$ID' AND `deleted` IS NOT NULL	ORDER BY `personID`");

				# note: price is calculated with defined discounts

				$SESSION_COEF = $ARTICLE_COEF = 1;

				if (($DATA['use_session_discount']) && ($DATA['session_discount']>0))	$SESSION_COEF = (100-$DATA['session_discount']) / 100;

				if (($DATA['use_article_discount']) && ($DATA['article_discount']>0))	$ARTICLE_COEF = (100-$DATA['article_discount']) / 100;

				$DATA['price_sum'] = $DATA['price_tax'] = $DATA['price_sum_tax'] = 0;				

				if ($this->SQL->num_rows())	{
				
					# Initialize vars
					
					$DATA['picture'] = $DATA['alt'] = $DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['sum'] = $DATA['sum_tax'] = array();

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())		{

						# create picture links & hover for each

						$PICTURE	=	'not_delivered';
						$ALT		=	$this->LANG->get('notdelivered');

						if ($RESULT['deliverylistID'])	{

							$PICTURE	=	'delivered';
							$ALT		=	$this->LANG->get('delivered').': '.$this->LANG->get('personIDlong').' '.$RESULT['deliverylistID'];

						}	else	{

							if ($productionorderID = $RESULT['productionorderID'])	{

								$this->SQL->query("	SELECT	`personID`
											FROM $this->BASE.production_orders_header
											WHERE	`personID`='$productionorderID' AND
												`date_of_finishing` IS NULL AND
												`deleted` IS NOT NULL LIMIT 1	");

								if ($this->SQL->num_rows())	{

									$PICTURE	=	'inproduction';
									$ALT		=	$this->LANG->get('inproduction').': '.$this->LANG->get('personIDlong').' '.$productionorderID;

								}	else	  {

									$PICTURE	=	'finished';
									$ALT		=	$this->LANG->get('finished').': '.$this->LANG->get('personIDlong').' '.$productionorderID;
								}
							}
						}

						$DATA['picture'][]	=	$PICTURE;
						$DATA['alt'][]		=	$ALT;

						# prices & sums

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['articalname'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];

						$PRICE			=	$RESULT['price']*$DATA['exchange_rate']*$SESSION_COEF*$ARTICLE_COEF;

						$DATA['price'][]	=	number_format($PRICE, 2, '.', '');
						
						$DATA['tax'][]		=	$RESULT['tax'];

						$SUM			=	$PRICE*$RESULT['quantity'];
						
						$TAX			=	$SUM * $RESULT['tax']/100;
						
						$SUM_TAX		=	$SUM + $TAX;

						$DATA['sum'][]		=	number_format($SUM, 2, '.', '');
						
						$DATA['sum_tax'][]	=	number_format($SUM_TAX, 2, '.', '');

						$DATA['price_sum']	+=	$SUM;
						
						$DATA['price_tax']	+=	$TAX;
						
						$DATA['price_sum_tax']	+=	$SUM_TAX;
					}
	
					unset($this->SQL->IT1_RESULT);
					
					$DATA['price_sum']	=	number_format($DATA['price_sum'], 2, '.', '');
					$DATA['price_tax']	=	number_format($DATA['price_tax'], 2, '.', '');
					$DATA['price_sum_tax']	=	number_format($DATA['price_sum_tax'], 2, '.', '');

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}
?>
