<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag production order delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PRODUCTIONORDERDELETE	{
	
		var	$STOCKTABLES = array(1=>'finished_goods_stock', 2=>'operating_suplies');

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];
	
			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{
		
			# note : no way to determine stock so lock them both

			$this->SQL->query("	LOCK TABLES 	$this->BASE.production_orders_header WRITE, 
								$this->BASE.production_orders_data WRITE, 
								$this->BASE.production_orders_phases WRITE, 
								$this->BASE.orders_data WRITE, 
								$this->STOCKBASE.finished_goods_stock WRITE,
								$this->STOCKBASE.operating_suplies WRITE, 
								$this->STOCKBASE.feedstock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID, $DATA)	{

			$ID		=	$this->SQL->escape($ID);

			$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']); 

			unset($DATA);

			$this->SQL->transaction();
		
			$this->lock();

			# check existsens, the order is not finished and read artical quantity

			$this->SQL->query("	SELECT `stocktype`, `orderID`, `code`, `date_of_finishing`, `quantity` 
						FROM $this->BASE.production_orders_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentproductionorder';
			}

			$RESULT	= $this->SQL->RESULT->fetch_assoc();

			if ($RESULT['date_of_finishing'])	{

				$this->SQL->rollback();

				$this->unlock();

				return 'finishedproductionorder';
			}

			$articalcode		=	$this->SQL->nr_escape($RESULT['code']);

			$articalquantity	=	$RESULT['quantity'];
			
			$STOCKTABLE		=	$this->STOCKTABLES[$RESULT['stocktype']];
			
			$orderID		=	$RESULT['orderID'];

			# update stock for quantity in production

			$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE
						SET quantity_in_production=quantity_in_production-$articalquantity
						WHERE `code`=$articalcode AND `deleted` IS NOT NULL LIMIT 1	");

			# delete header

			$this->SQL->query("	UPDATE $this->BASE.production_orders_header
						SET `deleted`=NULL , `delete_reason`=$delete_reason 
						WHERE `personID`='$ID' LIMIT 1	");

			# write back quantities into stock

			$this->SQL->query("	SELECT `code`, `quantity`, `type`
						FROM $this->BASE.production_orders_data
						WHERE `productionorderID`='$ID' AND `deleted` IS NOT NULL	");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT	= 	$this->SQL->RESULT;

				while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$code		=	$this->SQL->nr_escape($RESULT['code']);
					$SUM		=	$RESULT['quantity']*$articalquantity;
					
					if ($RESULT['type']=='a')	{
					
						$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock
									SET quantity_as_part=quantity_as_part-$SUM
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
					}	else	  {

						$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock
									SET	quantity_in_production=quantity_in_production-$SUM,
										quantity=quantity+$SUM
									WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
					}
				}

				unset($this->SQL->IT1_RESULT);
			}

			# delete feedstock

			$this->SQL->query("	UPDATE $this->BASE.production_orders_data
						SET `deleted`=NULL 
						WHERE `productionorderID`='$ID' AND `deleted` IS NOT NULL	");

			# delete production phase(s)
	
			$this->SQL->query("	DELETE FROM $this->BASE.production_orders_phases 
						WHERE `productionorderID`='$ID'		");

			# update order (if the production is not to stock)
			
			if ($orderID)	{

				$this->SQL->query("	UPDATE $this->BASE.orders_data 
							SET `productionorderID`=NULL
							WHERE `productionorderID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;			
		}
	}

?>
