<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag production order details
	 */ 
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PRODUCTIONORDERDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->BASE	=	$_SESSION['BASE'];
			
			$this->FEEDSTOCK_STR 	= $this->LANG->get('feedstock');
			
			$this->ARTICAL_STR 	= $this->LANG->get('artical');
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{	

			$this->SQL->query("LOCK TABLES	$this->BASE.production_orders_header WRITE, 
							$this->BASE.production_orders_data WRITE,
							$this->BASE.orders_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$DATA	=	FALSE;

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return $DATA;

			$this->lock();

			$this->SQL->query("	SELECT	`code` AS `articalcode`, `articalname`, `contactname`, `orderID`,
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`date_of_deadline`, '$this->FORMAT') AS `date_of_deadline`,
							DATE_FORMAT(`date_of_finishing`, '$this->FORMAT') AS `date_of_finishing`,
							`quantity` AS `articalquantity`, `defective_quantity`, `drawingID`, `technology`, `production_phase`  
						FROM $this->BASE.production_orders_header
						WHERE personID='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA		=	$this->SQL->RESULT->fetch_assoc();

				$DATA['productionorder_year']	=	str_replace('ebagdata', '' , $this->BASE);

				if (($DATA['defective_quantity']) && ($DATA['defective_quantity']>0))	{
				
				      $DATA['articalquantity'] .= ' ( '.$this->LANG->get('defective').' : '.$DATA['defective_quantity'].' )';
				      
				      unset($DATA['defective_quantity']);
				}
				
				if ($DATA['orderID'])	{

					# read number of order (orderID->no)
					
					$orderID = $this->SQL->nr_escape($DATA['orderID']);

					$this->SQL->query("	SELECT `productionorderID`
								FROM $this->BASE.orders_data 
								WHERE `orderID`=$orderID AND `deleted` IS NOT NULL ORDER BY `personID` ");

					if ($this->SQL->num_rows())	{

						$no	=	1;

						while ($RESULT = $this->SQL->RESULT->fetch_row())	{

				
							if ($RESULT[0]==$ID)	{

								$DATA['orderID'] .= '->'.$no;
								break;

							}	else	  {

								$no++;
							}
						}
					}
					
				}	else	  {
				
					# production order to stock
				
					$DATA['orderID'] = '-';
				}

				$this->SQL->query("	SELECT	`personID`, `code`, `name`, `quantity`, `unit`, `type`
							FROM $this->BASE.production_orders_data
							WHERE `productionorderID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID`	");

				if ($this->SQL->num_rows())	{
				
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['origin'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						
						if ($RESULT['type'] == 'f')	{$DATA['origin'][]=$this->FEEDSTOCK_STR;} else {$DATA['origin'][]=$this->ARTICAL_STR;}
					}

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
