<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag salary constants write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_real_positive');

	class SALARYGLOBALSWRITE	{	

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;
			
			$this->CONF	=	&$__CONF;

			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES ebag.settings WRITE");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLE');
		}

		public function write($DATA)	{

			unset($DATA['submit'], $DATA['name_str'], $DATA['base_str'], $DATA['value_str'], $DATA['start_str'], $DATA['previous_str']);


			if (	(! is_real_positive($DATA['overtime_work'])) or
				(! is_real_positive($DATA['night_work'])) or
				(! is_real_positive($DATA['holiday_work'])) or
				(! is_real_positive($DATA['sick_leave'])) or
				(! is_real_positive($DATA['annual_leave'])) or
				(! is_real_positive($DATA['holiday']))	)	return 'usererror';

			if (isset($DATA['additional_name']))	{

				if ($count = count($DATA['additional_name']))	{

					for ($i=0; $i<$count; $i++)	{

						# step over empty rows

						if (	(is_empty($DATA['additional_name'][$i])) &&
							(is_empty($DATA['additional_value'][$i]))	)	continue;

						if (! isset($DATA['additional_value'][$i]))	{

							$errtxt = 'usererror';
							break;
						}

						$DATA['additional_value'][$i] = (double)$DATA['additional_value'][$i];

						if (	(is_empty($DATA['additional_name'][$i])) or
							(is_empty($DATA['additional_base'][$i])) or
							(! is_real_positive($DATA['additional_value'][$i]))	)	{

							$errtxt = 'usererror';
							break;
						}
						
						if (! isset($PROCESSED['additional_name']))  $PROCESSED['additional_name']  = array();
						if (! isset($PROCESSED['additional_value'])) $PROCESSED['additional_value'] = array();
						if (! isset($PROCESSED['additional_base']))  $PROCESSED['additional_base']  = array();
		
						$PROCESSED['additional_name'][] 	=	htmlspecialchars($DATA['additional_name'][$i], $this->CONF->get('specialchars', 'flag'), 'UTF-8', FALSE);
						$PROCESSED['additional_value'][] 	=	$DATA['additional_value'][$i];
						$PROCESSED['additional_base'][]		=	$DATA['additional_base'][$i];
					}
				}
			}

			if (isset($errtxt)) return $errtxt;
	
			if (! isset($PROCESSED['additional_name']))	{

				unset($DATA['additional_name'], $DATA['additional_value'], $DATA['additional_base']);

			}	else	  {

				$DATA['additional_name']	=	$PROCESSED['additional_name'];
				$DATA['additional_value']	=	$PROCESSED['additional_value'];
				$DATA['additional_base']	=	$PROCESSED['additional_base'];
			}

			$SERIALIZED	=	$this->SQL->mysqli->real_escape_string(serialize($DATA));

			$this->SQL->transaction();
		
			$this->lock();

			$this->SQL->query("	DELETE FROM ebag.settings
						WHERE `key`='salary_constants' LIMIT 1	");

			$this->SQL->query("	INSERT INTO ebag.settings 
						VALUES
						('salary_constants', '$SERIALIZED')	");


			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
