<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service deatils read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SERVICELISTDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;
			
			$this->LANG	=	&$__LANG;
			
			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
			
			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}
	
		private function lock()	{

			$this->SQL->query("	LOCK TABLES	$this->BASE.services_header WRITE, 
								$this->BASE.services_data WRITE, 
								$this->BASE.feedstock_requests WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;
			
			# read payments
			
			$__PAYMENTS = new PAYMENTloader($this->APC);

			$PAYMENT_FORMS	= $__PAYMENTS->getnames();
			
			unset($__PAYMENTS);

			# read

			$DATA	=	FALSE;

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			# read header

			$this->SQL->query("	SELECT	`contactname`, `country`, `city`, `zip`, `street`, `service_discount`, 
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`date_of_deadline`, '$this->FORMAT') AS `date_of_deadline`, `payment_form`,
							DATE_FORMAT(`date_of_finishing`, '$this->FORMAT') AS `date_of_finishing`, 
							`delivery_day_of_week`, `comment`, `annotation`, `currency`, `exchange_rate`, `session_discount`,
							`use_session_discount`, `use_service_discount` 
						FROM $this->BASE.services_header  
						WHERE personID='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA			=	$this->SQL->RESULT->fetch_assoc();

				if (isset($PAYMENT_FORMS[$DATA['payment_form']])) $DATA['payment_form']	= $PAYMENT_FORMS[$DATA['payment_form']];

				unset($PAYMENT_FORMS);

				$DATA['delivery_day_of_week']	=	$this->LANG->get('day'.$DATA['delivery_day_of_week']);

				if (! $DATA['date_of_finishing']) $DATA['date_of_finishing'] = $this->LANG->get('no');

				# note adds year if is not current to display

				$DATA['service_list_year']	=	str_replace('ebagdata', '' , $this->BASE);

				# read data
		
				$this->SQL->query("	SELECT `code`, `servicename`, `quantity`, `unit`, `price`, `tax` 
							FROM $this->BASE.services_data 
							WHERE `reversID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

				# note: price is calculated with defined discounts

				$SESSION_COEF = $SERVICE_COEF = 1;

				if (($DATA['use_session_discount']) && ($DATA['session_discount']>0))	$SESSION_COEF = (100-$DATA['session_discount']) / 100;

				if (($DATA['use_service_discount']) && ($DATA['service_discount']>0))	$SERVICE_COEF = (100-$DATA['service_discount']) / 100;

				$DATA['price_sum'] = $DATA['price_tax'] = $DATA['price_sum_tax'] = 0;

				if ($this->SQL->num_rows())	{
				
					# Initialize vars
					
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['sum'] = $DATA['sum_tax'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['servicename'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];

						$PRICE			=	$RESULT['price']*$DATA['exchange_rate']*$SESSION_COEF*$SERVICE_COEF;

						$DATA['price'][]	=	number_format($PRICE, 2, '.', '');
						
						$DATA['tax'][]		=	$RESULT['tax'];

						$SUM			=	$PRICE*$RESULT['quantity'];
						
						$TAX			=	$SUM * $RESULT['tax']/100;
						
						$SUM_TAX		=	$SUM + $TAX;

						$DATA['sum'][]		=	number_format($SUM, 2, '.', '');
						
						$DATA['sum_tax'][]	=	number_format($SUM_TAX, 2, '.', '');

						$DATA['price_sum']	+=	$SUM;
						
						$DATA['price_tax']	+=	$TAX;
						
						$DATA['price_sum_tax']	+=	$SUM_TAX;
					}

					$DATA['price_sum']	=	number_format($DATA['price_sum'], 2, '.', '');
					$DATA['price_tax']	=	number_format($DATA['price_tax'], 2, '.', '');
					$DATA['price_sum_tax']	=	number_format($DATA['price_sum_tax'], 2, '.', '');

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}
?>
