<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag operating suplie request delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SUPLIEREQUESTDELETE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.suplie_request_header WRITE, 
								$this->BASE.suplie_request_data WRITE,
								$this->STOCKBASE.operating_suplies WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function delete($ID)	{

			$ID	=	$this->SQL->escape($ID);

			# start transaction

			$this->SQL->transaction();
		
			$this->lock();

			$this->SQL->query("	SELECT `date_of_creation`
						FROM $this->BASE.suplie_request_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentsuplierequest';
			}

			# write back suplies into stock

			$this->SQL->query("	SELECT `code`, `quantity`
						FROM $this->BASE.suplie_request_data
						WHERE `requestID`='$ID' AND `deleted` IS NOT NULL	");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$code		=	$this->SQL->nr_escape($IT1_RESULT['code']);
					$quantity	=	$IT1_RESULT['quantity'];
	
					$this->SQL->query("	UPDATE $this->STOCKBASE.operating_suplies 
								SET quantity=quantity+$quantity
								WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
				}
			}
			
			# delete header

			$this->SQL->query("	UPDATE $this->BASE.suplie_request_header 
						SET `deleted`=NULL 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			# delete data

			$this->SQL->query("	UPDATE $this->BASE.suplie_request_data
						SET `deleted`=NULL 
						WHERE `requestID`='$ID'	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;				
		}
	}

?>
