<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 4.0.0
	 */

	/**
	 * eBag employee working hours change (only one)
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	load_f('date2sql');

	class WORKINGHOURSCHANGE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'dateformat');
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.working_hours WRITE, 
								$this->BASE.employees WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function change($DATA)	{

			$ID	=	$this->SQL->escape($DATA['employeeID']);

			# check date

			if (! $date = date2sql($DATA['date'], $this->FORMAT)) return 'dateerror';

			# read state of checkboxes

			$CHECKBOXES	=	array('night_work', 'night_overtime_work', 'holiday_work', 'holiday', 'sick_leave', 'sick_leave_100', 'annual_leave');

			foreach ($CHECKBOXES as $BOX)	{

				if ((isset($_POST[$BOX])) && ($_POST[$BOX])) {${$BOX} = "'1'";} else {${$BOX} = "'0'";}
			}

			if (is_empty($DATA['work_hours'])) 		$DATA['work_hours'] = 0;

			if (is_empty($DATA['overtime_work_hours'])) 	$DATA['overtime_work_hours'] = 0;

			$work_hours		=	(double)$DATA['work_hours'];

			$overtime_work_hours	=	(double)$DATA['overtime_work_hours'];
			
			if (($work_hours <= 0) or ($overtime_work_hours < 0)) return 'usererror';

			# write

			$this->SQL->transaction();
		
			$this->lock();

			# check for entry before

			$this->SQL->query("	SELECT `personID`
						FROM $this->BASE.working_hours
						WHERE `employeeID`='$ID' AND `date`='$date' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentworkinghours';
			}

			$this->SQL->query("	SELECT `employeename`
						FROM $this->BASE.employees
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentemployee';
			}

			$RESULT 	=	$this->SQL->RESULT->fetch_row();

			$employeename	=	$this->SQL->nr_escape($RESULT[0]);

			$this->SQL->query("	UPDATE $this->BASE.working_hours
						SET 	`employeename`=$employeename, `date`='$date', `work_hours`='$work_hours', `overtime_work_hours`='$overtime_work_hours',
							`night_work`=$night_work, `night_overtime_work`=$night_overtime_work, `holiday_work`=$holiday_work, `sick_leave`=$sick_leave,
							`sick_leave_100`=$sick_leave_100, `annual_leave`=$annual_leave, `holiday`=$holiday
						WHERE `employeeID`='$ID' AND `date`='$date' AND `deleted` IS NOT NULL LIMIT 1	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
