<?php
      	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * returns eBag requested salary comment & annotation
	 */
	
	if (	(! isset($_GET['employee_id'])) or 
		((! isset($_GET['person_id'])) && (! isset($_GET['month'])) && (! isset($_GET['semimonth'])))	) exit;
	 
	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# Sets session handler (important to refresh the session)

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	if (isset($_SESSION['permission'])) {$_SESSION['permission'] = $_SESSION['permission'];} else {exit;}
	
	# create connection
	
	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;
	
	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");
	
	foreach (array('employee_id', 'person_id', 'month', 'semimonth') as $key)	{
	
		  if (! isset($_GET[$key])) {$_GET[$key]=FALSE; continue;}
		  
		  if (get_magic_quotes_gpc()) $_GET[$key] = stripslashes($_GET[$key]);
	
		  $_GET[$key] = $mysqli->real_escape_string(htmlspecialchars($_GET[$key], $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));
	}
	
	extract($_GET);
	
	if ($month) $part='0';
	
	if ($semimonth)	{
	
		$month = ceil($semimonth/2);
	
		if ($semimonth % 2) {$part = 1;} else {$part = 2;}
	}
	
	if ($month) $WHERE = " `employeeID`='$employee_id' AND `month`='$month' AND `month_part`='$part' AND `deleted` IS NOT NULL ";
	
	if ($person_id) $WHERE = " `personID`='$person_id' AND `deleted` IS NOT NULL ";
	
	if (! isset($WHERE)) exit;
	
	# header
	
	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT'); 
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/xml');

	# read
	
	$result = $mysqli->query("	SELECT `personID`, `employeeID` as `employee_id`, `month`, `month_part`, `comment`, `annotation` 
					FROM ebagdata{$_SESSION['year']}.salarys 
					WHERE $WHERE LIMIT 1	");
						
	if (! $result->num_rows) exit('1');
	
	extract($result->fetch_assoc());
	
	if ($month_part)	{
	
		$semimonth = ($month - 1) * 2 + $month_part;
	
		$month = '';
	      
	}	else	  {
	
		$semimonth = '';
	}
	
	echo  '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n"
	     ."<response>\r\n<data>\r\n<person_id>$personID</person_id>\r\n<employee_id>$employee_id</employee_id>\r\n<month>$month</month>\r\n"
	     ."<semimonth>$semimonth</semimonth>\r\n<comment>$comment</comment>\r\n<annotation>$annotation</annotation>\r\n</data>\r\n</response>";
	
?>